/*
 *	FILE	 : ga0->c
 *	SYSTEM	 : `ASY(GA:Genetic Algorithm)
 *	FUNCTION :
 *	AUTHER	 : s.kobayashi 1994/01/14
 *	MODIFY	 : Y.Shibasaki 2013.04.19 NX
 */
//#include	<stdafx.h>
#pragma warning(disable:4996)
#include	<stdio.h>
#include	<stdlib.h>
#include	<malloc.h>
#include	<memory.h>
#include	<string.h>
#include	<limits.h>
#include	<time.h>

#include	"ssc.h"
#include	"gaparm.h"
#include	"ga1.h"
//#include	"gatsp.h"
#ifdef Z0
struct edgelist_st {
	int		num;     //[0], [1]eP̒́ȂOƌ̓ss
	                    //[2], [5]eQ̒́ȂOƌ̓ss
	int		num;        //ss
};
struct edgelist_st *edge;
#endif

#ifdef Z0 // wb_[(ga1.h) 2013.09.04 YS
GA1::GA1()
{
	oya_gcro = NULL;
	ko_gcro = NULL;
	kousa = NULL;
	intgcro = NULL;
	allele = NULL;
	order = NULL;
	chk = NULL;
	taro_gcro.chrom = NULL;
	hana_gcro.chrom = NULL;
	sawkval = NULL;
	sawkkousa = NULL;
	edgelist= NULL;
	ans = NULL;
	rank= NULL;
	sagyo = NULL;
	mcn = NULL;
	route_num= NULL;
	xy_cost= NULL;
	xcoord= NULL;
	ycoord= NULL;
}
#endif // wb_[(ga1.h) 2013.09.04 YS

/*	ID_GA1::get_ga1_popul_size	ga1̌̐擾
********************************************************************/
int GA1::get_ga1_popul_size()
{
	return( x_ko);
}
/*	ID_GA1::get_ga1_gcro	 ga1̐eF̏擾
********************************************************************/
int GA1::get_ga1_gcro(
int no,
int	*gcro)
{
	int		rc = 0, size;

	if( no < 0 || no >= x_ko)	 return(-1);
	size = sizeof(*oya_gcro[no].chrom) * x_len;  // debug
	memcpy(gcro,oya_gcro[no].chrom,sizeof(*oya_gcro[no].chrom) * x_len);
	return(0);
}
double GA1::bekiFITNES( //chrom, len, kai ) /* IIIlongdoubleɕύX(94.2.21) */
	int 	*chrom,
	int 	len ,
	double	*kai,
	struct gaparm * gap)
	//class GA1 *ga0) // ԂĂȂ@max_spnԂ悤ɏC
{
	double	dwk, rc;
	double	max_span ;
	int			j;

//	max_span = Eval( n_job, n_mcn, sagyo, chrom, mcn );
	*kai = max_span = Eval( gap->gene_number, gap->allele_number, sagyo, chrom, mcn ); CHKAD(0.0, 0.0, max_span); //NT130207add CHK
	dwk = ( total_sagyo  / max_span ) ;
	rc = 100.0 * dwk * dwk;    /* ׂXP[O */
	if( rc <= 0.0 ) CHKAD(0.0, 0.0, rc);

	if( DBGF[20]) {
		for ( j=0 ; j<len ;j++ ) 	fprintf(logfp,"%d ",chrom[j]);
		fprintf(logfp,"fitness(%lf)\n",rc);
	}

	return( rc ) ;
}
/* uqopKxZo */
double GA1::bekiFITNES_VRP( //chrom, len, kai ) /* IIIlongdoubleɕύX(94.2.21) */
	int 	chrom[],
	int 	len ,
	double	*kai,
	struct gaparm * gap,
	double	*route_max) // route_max Ԃ 2015.11.20 YS@SHԂƂɂ̂ŁAݎgȂÂ܂܂ɂĂ 2015.11.20 YS
{
	double	dwk, rc;
	int		i, first, next = -1, rno = 0;
	double	total = 0.0;

	*route_max = 0.0;
	/* _ʂĂȂ̃`FbN */
	//if( DBGF[20]> 0) chk_same_point_tsp(chrom, len,chk); // IMADAKE
	/* e[g̒̍őlقǓKx */
	/* őlƑS߂ */
	route_num[rno] = 0.0;
	for( i = 0; i < len-1; i++ ) {
		first = chrom[i];			//CHKA(0,first,gap.gene_number); TODO
		//if( i+1 == len ) 	next = chrom[0];
		//else				next = chrom[i+1];
		next = chrom[i+1];
			// CHKA(0,next,gap.gene_number); TODO
		/* dCɊU邽߂̂̂ȂAŌɋN_ɖ߂鋗𑫂Kv͂Ȃ */
		/* ŁAv */
		total += sagyo[first][next];
		route_num[rno] += sagyo[first][next];
		/* Zp[^Ȃ */
		if( first >= gap->gene_number - gap->allele_number + 1) {
			if( route_num[rno] > *route_max ) *route_max = route_num[rno];
			rno++;
			route_num[rno] = 0.0;
		}
	}
	if( route_num[rno] > *route_max ) *route_max = route_num[rno];
	if( next >= gap->gene_number - gap->allele_number + 1) {// ŌオZp[^Ȃ
		rno++;
		route_num[rno] = 0.0;
	}
	CHKB(gap->allele_number-1,rno,gap->allele_number-1);
	CHKBD(0.01, total,total);
	CHKBD(0.01, *route_max,total);
	//dwk = ( total_sagyo  /route_max ) ;
	// [g̍őlقǓKx[
	// [g̍őlقǓKx & őlȂg[^lZ̓Kx
	/* eXg@g[^lZقǂ悢悤ɕύXĂ݂ */
	dwk = ( total_sagyo  / ( *route_max * gap->allele_number + total)) ;
	/*dwk = 1.0  / ( route_max + total);*/
	/*dwk = ( ga0->total_sagyo	/ ( route_max + total)) ;*/
	/* bekiFITNES()ƓɂĂ݂ */
	/*first = next;
	/*next = chrom[0];
	/*total += ga0->sagyo[first][next];
	/*dwk = ( ga0->total_sagyo	/ total) ;*/

	rc = 100.0 * dwk * dwk;    /* ׂXP[O */
	if( rc <= 0.0 ) CHKAD(0.0, 0.0, rc);

	if( DBGF[20]) {
		for ( i=0 ; i<len ;i++ ) 	fprintf(logfp,"%d ",chrom[i]);
		fprintf(logfp,"fitness(%lf)\n",rc);
		for ( i=0 ; i<=rno ;i++ ) 	fprintf(logfp,"%lf ",route_num[i]);
		fprintf(logfp,"total(%lf)\n",total); fflush(logfp);
	}
	//*kai = route_max;
	//route_max = route_max;
	*kai = total;
	return( rc ) ;
}


/*	ID_CheckCr	_Qxʉ߂ĂȂǂA`FbN֐
********************************************************************/
static int CheckCr( 
	 int ch[],
	 int len,
	 class GA1	*c)
{
	int i ;
	 int gVal=0 ; // lsroł́Asroŋ߂[g𕪊Âꂼɂf`sĂ̂ŁAstatic͂܂I@̊֐̂Ȃ
	int cVal=0 ;
	if ( !c->gap.locus_unique ) return( 0 ) ; //ŏ̃f[^trycount݂邪AAˑRψقsAtrycountł͂ȂȂ̂
	if ( gVal <= 0 ) {
			for ( i=0 ;i<c->x_len ; i++ ) gVal += ch[i] ;
	}
	for( i=0 ; i<len ; i++ ) cVal += ch[i] ;
	if ( gVal != cVal )  CHKB(gVal,cVal,gVal) ;
	return(0) ;
}
//#endif

/*	ID_oya_comp	IςۂƓKŔr
********************************************************************/
static int oya_comp( const void *a, const void *b )
{
	register int 	rc;
	struct gcrowk_st	*p,*q;
	//p = (int *)a; q = (int *)b;
	//if( (rc= c.oya_gcro[*p].selsumi - c.oya_gcro[*q].selsumi) == 0 )
	//	if	   ( c.oya_gcro[*p].fitnes	> c.oya_gcro[*q].fitnes ) rc = -1;
	//	else if( c.oya_gcro[*p].fitnes	< c.oya_gcro[*q].fitnes ) rc = 1;
	//	else   rc = 0;
	p = (struct gcrowk_st *)a; q = (struct gcrowk_st *)b;
	if( (rc= p->selsumi - q->selsumi) == 0 )
		if	   ( p->fitnes	> q->fitnes ) rc = -1;
		else if( p->fitnes	< q->fitnes ) rc = 1;
		else   rc = 0;
	return( rc );
}
/* _ʂĂȂ̃`FbN */ /* CheckCr()łȂAvłႤP[X邽 */
 int chk_same_point_ga1(
	int	*path,
	int	num,
	int	*chk)
{
	int	rc = 0, i, j, chk_No;

	chk_No = chk[0];
	for( i = 0; i < num; i++ ) {
		j = path[i];	CHKA(0,j,num);		CHKB(chk_No,chk[j],chk_No);
		chk[j]++;
	}
	return(rc);
}

/*	ID_gaELITE	 G[gI
********************************************************************/
static int gaELITE( //i_elite, otikobore, w_gcro, w_num )
	register int 	*i_elite,
	register int 	*otikobore,
	register GCRO	*w_gcro,
	register int 	w_num)
{
	register int 	i ;
	register double	dwk, dmax, dmin;
	if (DBGF[2]>1) fprintf(logfp, "gaELITE >>>\n") ;
	*i_elite = *otikobore = -1 ;
	for ( i = 0 ; i < w_num ; i++, ++w_gcro ) {
		if( w_gcro->selsumi ) continue;
		dwk = w_gcro->fitnes;
		if( *i_elite < 0 ) {
			*i_elite = *otikobore = i;
			dmax = dmin = dwk;
		} else if ( dwk > dmax ) {
			*i_elite = i ;
			dmax = dwk;
		} else if ( dwk < dmin ) {
			*otikobore = i ;
			dmin = dwk;
		}
	}
	CHKA(0, *i_elite, w_num);
	CHKA(0, *otikobore, w_num);
	if (DBGF[2]) fprintf(logfp, "<<< gaELITE i_elite(%d)otikobore(%d)dmax(%lf)\n", *i_elite, *otikobore, dmax ) ;
	return( 0 ) ;
}
#ifdef Z0
/*	ID_oya_comp2	
********************************************************************/
int oya_comp2( const void *p, const void *q )
//	int 	*p, *q;
{
	register int 	rc, i;
	register struct gcrowk_st	*gp, *gq;
	//gp = &c.oya_gcro[*((int *)p)];
	//gq = &c.oya_gcro[*((int *)q)];
	gp = (struct gcrowk_st *)p;
	gq = (struct gcrowk_st *)q;
	if	   ( gp->fitnes  > gq->fitnes ) rc = -1;
	else if( gp->fitnes  < gq->fitnes ) rc = 1;
	else  {
		register int 	*ip, *iq;
		ip =gp->chrom;
		iq =gq->chrom;
		//i = c.x_len ;
		i = sizeof(gp->chrom ) / sizeof( gp->chrom[0] );  //oOǖgp KS130819
		while( i-- )
			if( *ip++ != *iq++ ) break;
		if( i < 0 ) rc = 0;
		else		rc = *(ip-1) - *(iq-1);
	}
	return( rc );
}

/*	ID_gaSHARE	VFAÔƂɓ̂̑Iς݃tOIɂ
********************************************************************/
int gaSHARE(
	 GCRO *w_gcro,
	 class GA1	*c)
{
	int 	i, j, k, rc = 0;
	register GCRO	*gj, *gk;

	//for( i = 0 ; i < c.x_ko ; ++i ) c.order[i] = i;
	//qsort( c.order, c.x_ko, sizeof(*c.order), QSORT_TYP oya_comp2 );
	//qsort( c.order, c.x_ko, sizeof(*c.order), oya_comp2 );
	for( i = 0 ; i < c->x_ko ; ++i ) {
		c->sortwk[i].no = i; c->sortwk[i].fitnes = w_gcro[i].fitnes;c->sortwk[i].selsumi = w_gcro[i].selsumi;
		memcpy(c->sortwk[i].chrom, w_gcro[i].chrom,sizeof(w_gcro[i].chrom)*c->x_len  );
	}
	qsort( c->sortwk, c->x_ko, sizeof(*c->sortwk), QSORT_TYP oya_comp2 );


	k = c->sortwk[0].no; 		   CHKA(0,k,c->x_ko);
	gk = &w_gcro[k];
	for( i = 1 ; i < c->x_ko ; ++i, gk = gj ) {
		//j = c->sortwk[0].no; 		   CHKA(0,j,c->x_ko);
		j = c->sortwk[i].no; 		   CHKA(0,j,c->x_ko);
		gj = &w_gcro[j];
		if( gj->fitnes != gk->fitnes ) continue;
		if( memcmp( gj->chrom, gk->chrom, sizeof(int)*c->x_len ) == 0 ) {
			gj->selsumi = 1;
			++rc;
		}
	}
	if (DBGF[3]) fprintf(logfp, "<<< gaSHARE rc(%d)\n", rc );
	return( rc );
}
#endif
/*	ID_oya_comp3	
********************************************************************/
static int oya_comp3( void *pp0,const int p, const int q )
//	int 	*p, *q;
{
	register int 	rc, i;
	register  GCRO	*gp, *gq;
	GCRO *pp;
//	pp = (GCRO *)pp0;
	pp = ((GA1*)pp0)->oya_gcro;   //NT130820chg

	gp = &pp[p];
	gq = &pp[q];
	//gp = (struct gcrowk_st *)p;
	//gq = (struct gcrowk_st *)q;
	if	   ( gp->fitnes  > gq->fitnes ) rc = -1;
	else if( gp->fitnes  < gq->fitnes ) rc = 1;
	else  {
		register int 	*ip, *iq;
		ip =gp->chrom;
		iq =gq->chrom;
		//i = c.x_len ;
		//i = sizeof(gp->chrom ) / sizeof( gp->chrom[0] );
		i = ((GA1*)pp0)->x_len;   //NT130820chg
		while( i-- )
			if( *ip++ != *iq++ ) break;
		if( i < 0 ) rc = 0;
		else		rc = *(ip-1) - *(iq-1);
	}
	return( rc );
}
#define Size_t int

/*	ID_qsortx	
********************************************************************/
void qsortx(
  Size_t *wk,	  //io ́F\[gΏۂary[]̓YXgBóF\[g̓YXgB
  Size_t n_wk,	  //i \[gΏۂ̃f[^Bwk[]̃f[^B
  int (*p_comp) (void *ary, const int, const int), //i	r֐Bqsort()ƓlɂQ&ary[]ĔrB
  void *ary);	   //i \[gΏۂ̔Cӌ^̔z

/*	ID_gaSHARE	 VFAÔƂɓ̂̑Iς݃tOIɂ
********************************************************************/
static int gaSHARE( 
	 GCRO *w_gcro,
	 class GA1	*c)
{
	int 	i, j, k, rc = 0;
	register GCRO	*gj, *gk;

	for( i = 0 ; i < c->x_ko ; ++i ) c->order[i] = i;
//	qsortx( c->order, c->x_ko, oya_comp3,w_gcro );
	qsortx( c->order, c->x_ko, oya_comp3, c );			  //NT130820chg
	//qsort( c->order, c->x_ko, sizeof(*c->order), oya_comp2 );
	//for( i = 0 ; i < c->x_ko ; ++i ) {
	//	c->sortwk[i].no = i; c->sortwk[i].fitnes = w_gcro[i].fitnes;c->sortwk[i].selsumi = w_gcro[i].selsumi;
	//	memcpy(c->sortwk[i].chrom, w_gcro[i].chrom,sizeof(w_gcro[i].chrom)*c->x_len  );
	//}
	//qsort( c->sortwk, c->x_ko, sizeof(*c->sortwk), QSORT_TYP oya_comp2 );


	k = c->order[0]; 		   CHKA(0,k,c->x_ko);
	gk = &w_gcro[k];
	for( i = 1 ; i < c->x_ko ; ++i, gk = gj ) {
		j = c->order[i]; 		   CHKA(0,j,c->x_ko);
		gj = &w_gcro[j];
		if( gj->fitnes != gk->fitnes ) continue;
		if( memcmp( gj->chrom, gk->chrom, sizeof(int)*c->x_len ) == 0 ) {
			gj->selsumi = 1;
			++rc;
		}
	}
	if (DBGF[3]) fprintf(logfp, "<<< gaSHARE rc(%d)\n", rc );
	return( rc );
}

/*	ID_gaPROB	 ImvZ ҒlƂăe[uɃZbg
********************************************************************/
static int gaPROB( /*total_prob, total_hope, selec_type, w_gcro)*/
	double	*total_prob,	// o Im
	double	*total_hope,	// o Ғl
	int		selec_type,		// i eo@@/* 1:[bg 2:N 3:Ғl */
	GCRO	*w_gcro,		// i F̏
	class GA1	*ga0)
{
	int 	rc=0, j ;
	register int 	i;
	double	total_fitnes ;
	register double	dwk, dw2;
	register GCRO	*w_g;

	switch ( selec_type ) {
	case SELEC_TYPE_RAND : ; 	/* [bg헪AKxImƂ */
	case SELEC_TYPE_HOPE :		/* Ғl헪 */
		total_fitnes = 0.0;
		for ( w_g = w_gcro, i = 0 ; i < ga0->x_ko ; i++, ++w_g ) {
/*			if( ! w_g->selsumi )*/
			if( !w_g->selsumi && w_g->fitnes >= 0 ) /*07/29*/
				total_fitnes += w_g->fitnes;
		}
/*???ȂKvs		if( total_fitnes <= EPS ) CHKB(-1,(long)total_fitnes,0); //v`q*/
		*total_prob = 0.0 ;
/*		dw2 = 1.0 / total_fitnes;*/
		if ( total_fitnes >= -EPS && total_fitnes <= EPS ) dw2 = 1.0 ;	/* = 0 07/29*/
		else													 dw2 = 1.0 / total_fitnes;
		for ( w_g = w_gcro, i = 0 ; i < ga0->x_ko ; i++, ++w_g ) {
/*			if( w_g->selsumi ) dwk = 0.0;*/
			if( w_g->selsumi || w_g->fitnes < 0 ) dwk = 0.0; /*07/29*/
			else			   dwk = w_g->fitnes * dw2;
			w_g->prob	 = dwk;
			*total_prob += dwk;
		}
		break ;
	case SELEC_TYPE_RANK : /* rank[] kara sentaku kakuritu get */
		//for( i = 0 ; i < ga0->x_ko ; ++i ) ga0->order[i] = i;
		for( i = 0 ; i < ga0->x_ko ; ++i ) {ga0->sortwk[i].no = i; ga0->sortwk[i].fitnes = w_gcro[i].fitnes; ga0->sortwk[i].selsumi = w_gcro[i].selsumi;}
		//qsort( ga0->order, ga0->x_ko, sizeof(*ga0->order), QSORT_TYP oya_comp );
		qsort( ga0->sortwk, ga0->x_ko, sizeof(*ga0->sortwk), QSORT_TYP oya_comp );
		*total_prob = 0.0 ;
/*		for( i = ga0->x_ko-1 ; i >= 0 ; --i ) { } */
		for( i = 0 ; i < ga0->x_ko ; ++i ) {
			//j = ga0->order[i]; 		   CHKA(0,j,ga0->x_ko);
			j = ga0->sortwk[i].no; 		   CHKA(0,j,ga0->x_ko);
			w_g = &w_gcro[j];
			if( w_g->selsumi ) dwk = 0.0;
			else			   dwk = ga0->gap.rank[i] ;
			w_g->prob = dwk;
			*total_prob   += dwk;
		}
		break ;
	default :
		*total_prob = 0.0 ;
		dwk = 1.0 / ga0->x_ko;
		for ( i=0 ; i<ga0->x_ko ; i++ ) {
			w_gcro[i].prob = dwk;
			*total_prob   += dwk;
		}
		break;
	} /* end of switch */
	*total_hope = 0.0 ;
	if( *total_prob > EPS || *total_prob < -EPS ) dw2 = ga0->x_ko / *total_prob ;
	else                    dw2 = 0.0;
	for ( w_g = w_gcro, i = 0 ; i < ga0->x_ko ; i++, ++w_g ) {
		dwk = w_g->prob * dw2;
		w_g->expec	 = dwk;
		*total_hope += dwk;
	}
/*quit :*/ if(DBGF[4]) fprintf(logfp, "gaPROB >>><<< total_prob(%e)total_hope(%e)\n",
							*total_prob, *total_hope );
	return( rc ) ;
}
/*	ID_gaCHANGE_PROB	 Ғl̍XV
********************************************************************/
static int gaCHANGE_PROB(// papa, mama, total_hope )
	register GCRO	*papa,
	register GCRO	*mama,
	double	*total_hope,
	class GA1	*ga0)
{
	register double	dwk;
	if( ga0->gap.with_repla == WITH_REPLA_OFF ) { 	/* 񕜌o */
		papa->selsumi = 1 ;
		mama->selsumi = 1 ;
		*total_hope -= papa->expec+mama->expec;
		papa->expec  = 0.0;
		mama->expec  = 0.0;
	} else if ( ga0->gap.selec_type == SELEC_TYPE_HOPE ) { /* 0.5Ђ */
		if( (dwk = papa->expec) > 0.5 ) {
			*total_hope -= 0.5;
			papa->expec -= 0.5;
		} else {
			*total_hope -= dwk;
			papa->expec  = 0.0;
			papa->selsumi = 1 ;
		}
		if( (dwk = mama->expec) > 0.5 ) {
			*total_hope -= 0.5;
			mama->expec -= 0.5;
		} else {
			*total_hope -= dwk;
			mama->expec  = 0.0;
			mama->selsumi = 1 ;
		}
	}
	if(DBGF[5]) fprintf(logfp, "gaCHANGE_PROB >>><<< total_hope(%le)\n", *total_hope );
	return( 0 );
}
/*	ID_gaPAIR	 ẽyA쐬
********************************************************************/
static int gaPAIR(// w_gcro, with_repla, sharing, osu, mesu, total_hope ) 
	GCRO	*w_gcro,
	int 	with_repla,
	int 	sharing,
	int 	*osu,
	int 	*mesu,
	double total_hope,
	class GA1 *ga0)
{
	int 	rc=0, num=0 ;
	register int 	i;
	register double	valp, ac ;
	register GCRO	*w_g;
	double	old_total ;

	if (DBGF[6]){ fprintf(logfp, "gaPAIR w_gcro(%lx)repla(%d)shar(%d)total_hope(%lf)\n",
			w_gcro,with_repla,sharing,total_hope) ;
	}
	old_total = total_hope;
	*osu = *mesu = -1 ;
/* osu */
	valp = ga0->RANDsk( ) * old_total ;
									   CHKAD(0.0,valp,old_total); /* >=0*/
	for( ac = 0.0, w_g = w_gcro, i = 0 ; i < ga0->x_ko ; i++, ++w_g ) {
		if( w_g->selsumi ) continue;
		ac += w_g->expec;
		if ( valp <= ac ) break ;
	}								   CHKBD(ac,ac,old_total);
	if( i >= ga0->x_ko )							  goto err1;
	*osu = i;
	w_gcro[*osu].selsumi = 1;	/* ꎞIɑIς݃tOnmƂ */
	old_total -= w_gcro[i].expec;
/* 	mesu */
	valp = ga0->RANDsk( ) * old_total ;	/* >=0*/
									   //CHKAD(0.0,valp,old_total);
									   CHKBD(0.0,valp,old_total);// 2013.10.15 YS
	for( ac = 0.0, w_g = w_gcro, i = 0 ; i < ga0->x_ko ; i++, ++w_g ) {
		if( w_g->selsumi ) continue;
		ac += w_g->expec;
		if ( valp <= ac ) break ;
	}								   CHKBD(ac,ac,old_total);
	w_gcro[*osu].selsumi = 0;
	if( i >= ga0->x_ko )							  goto err1;
	*mesu = i;
quit :
	if (DBGF[6]) fprintf(logfp, "<<< gaPAIR osu(%d)mesu(%d)n_ko(%d)n_loop(%d)gap(%d)\n",
					*osu, *mesu, ga0->n_ko, ga0->n_loop, ga0->gap.gener_gap ) ;
	return( rc ) ;
err1 : fprintf(logfp, "ẽyAȂ!!!!!\n") ; fflush(logfp); //KS130918 fflush ǉ
	rc = -1 ; goto quit ;
}
/*	ID_GA1::gaKOUSA	 eq邩H
********************************************************************/
	int GA1::gaKOUSA( double cross_rate )
	//double	cross_rate ;
{
	int 	rc=0 ;

	rc = RANDsk() <= cross_rate ;
	if (DBGF[6]) fprintf(logfp, "gaKOUSA === rc(%d)cross_rate(%lf)\n",rc,cross_rate ) ;
	return( rc ) ;
}

/*	ID_gaMUTAT	 qPAqQ̐F̂ɓˑRψقs
********************************************************************/
static int gaMUTAT( //mutat_typ, mutat_rate, chrom_oya1, chrom_oya2, chrom_ko1, chrom_ko2 )/* rc = 1:ˑRψق 0:Ȃ */
	int		mutat_typ	,  /* 0:m[} 1:^ 2:}^ 3:2OPT^ */
	double	mutat_rate	,  //
	int 	chrom_oya1[],  //
	int 	chrom_oya2[],  //
	int 	chrom_ko1[] ,  //
	int 	chrom_ko2[] ,  //
	class GA1	*ga0)
{
	int 	rc=0, i, ici = -1 ;
	int 	val0, val1 ;
	int		ici2 ;
	int   *b1, *b2 ;
	int		wici, wici2, old_wici2;

	if( DBGF[6] )  fprintf(logfp, "gaMUTAT >>> mutat_rate(%lf)\n",mutat_rate) ;
	if ( mutat_typ == GA_MUTYP_NORMAL ) { /* NORMAL*/
		if ( ga0->gap.locus_unique ) goto quit ; /*Ԃl̔*/
		for ( i=0 ;i<2 ;i++ ) {
			if ( ga0->RANDsk() > mutat_rate ) continue;	/* ˑRψڂȂ */
			ici  = (int)(ga0->RANDsk() * ga0->x_len) ;	  	CHKA(0,ici,ga0->x_len);
			val0 = (int)(ga0->RANDsk() * ga0->allele[ici]) ; CHKA(0,val0,ga0->allele[ici]);
			if ( i == 0 ) chrom_ko1[ici] = val0 ;
			else		  chrom_ko2[ici] = val0 ;
		}
	} else { /*98/06 >>>*/
		if ( ga0->RANDsk() > mutat_rate ) goto quit;  /* ˑRψڂȂ */
		ici  = (int)(ga0->RANDsk() * ga0->x_len) ;	  	CHKA(0,ici,ga0->x_len);
		ici2 = (int)(ga0->RANDsk() * ga0->x_len) ;    	CHKA(0,ici2,ga0->x_len);
		if( DBGF[8]>1) {
			CheckCr( chrom_ko1, ga0->x_len, ga0 ) ;
			CheckCr( chrom_ko2, ga0->x_len, ga0 ) ;
			fprintf(logfp, "ici(%d)ici2(%d)\n", ici, ici2 ) ;
			for ( i=(ici<ici2?ici:ici2)-1 ; i<=(ici>ici2?ici:ici2)+1 ; i++ ) {
				if ( i < 0 || i >= ga0->x_len ) continue ;
				fprintf(logfp, "(%d)  %d  %d\n",i,chrom_ko1[i], chrom_ko2[i] ) ;
			}
		}
		if ( mutat_typ == GA_MUTYP_CHANGE ) { /*^i^jF[ici][ici2]̒l*/
			val0 = chrom_ko1[ici] ;
			chrom_ko1[ici] = chrom_ko1[ici2] ;
			chrom_ko1[ici2] = val0 ;

			val0 = chrom_ko2[ici] ;
			chrom_ko2[ici] = chrom_ko2[ici2] ;
			chrom_ko2[ici2] = val0 ;
		} else if ( mutat_typ == GA_MUTYP_INSERT ) { /*}^iʒu^jF[ici]̑O[ici2]̒l*/
			val0 = chrom_ko1[ici2] ;
			val1 = chrom_ko2[ici2] ;
			if ( ici2 > ici ) { /*[ici][ici2-1]EɂPړ*/
							CHKA(1,ici2,ga0->x_len) ;
							CHKA(0,ici, ga0->x_len) ;
				b1 = &chrom_ko1[ici2-1] ;
				b2 = &chrom_ko2[ici2-1] ;
				while( (char*)b1 >= (char*)(&chrom_ko1[ici]) ) {
					*(b1+1) = *b1 ;
					*(b2+1) = *b2 ;
					b1--, b2-- ;
				} /* insert[ici]*/
				*++b1 = val0 ;			CHKB((char*)(&chrom_ko1[0]), (char*)b1, (char*)(&chrom_ko1[ga0->x_len-1])) ;
				*++b2 = val1 ;			CHKB((char*)(&chrom_ko2[0]), (char*)b2, (char*)(&chrom_ko2[ga0->x_len-1])) ;
			} else {						/*[ici2+1][ici-1]ɂPړ*/
							CHKA(0,ici2,ga0->x_len) ;
							CHKA(0,ici, ga0->x_len) ;
				if ( ici2 == ga0->x_len - 1 ) goto quit ;
				b1 = &chrom_ko1[ici2+1];
				b2 = &chrom_ko2[ici2+1] ;
				while( (char*)b1 < (char*)&chrom_ko1[ici] ) {
					*(b1-1) = *b1 ;
					*(b2-1) = *b2 ;
					b1++, b2++ ;
				} /* insert[ici-1]*/
				*--b1 = val0 ;			CHKB((char*)(&chrom_ko1[0]), (char*)b1, (char*)(&chrom_ko1[ga0->x_len-1])) ;
				*--b2 = val1 ;			CHKB((char*)(&chrom_ko2[0]), (char*)b2, (char*)(&chrom_ko2[ga0->x_len-1])) ;
			}
		} else if ( mutat_typ == GA_MUTYP_2OPT ) { /*2OPT^A2œKF[ici][ici2]̊Ԃ𔽓]*/
			wici = ici; wici2 = old_wici2 = ici2;
			//while( wici != wici2 ) {
			while( wici != wici2 && wici != old_wici2) {
				val0 = chrom_ko1[wici] ;
				chrom_ko1[wici] = chrom_ko1[wici2] ;
				chrom_ko1[wici2] = val0 ;
				wici++;
				old_wici2 = wici2;
				wici2--;
				if( wici2 < 0 ) wici2 = ga0->x_len-1;
				if( wici >= ga0->x_len ) wici = 0;
			}
			wici = ici; wici2 = old_wici2 = ici2;
			//while( wici != wici2 ) {
			while( wici != wici2 && wici != old_wici2) {
				val0 = chrom_ko2[wici] ;
				chrom_ko2[wici] = chrom_ko2[wici2] ;
				chrom_ko2[wici2] = val0 ;
				wici++;
				old_wici2 = wici2;
				wici2--;
				if( wici2 < 0 ) wici2 = ga0->x_len-1;
				if( wici >= ga0->x_len ) wici = 0;
			}
		}
		else {CHKA(-1,-1,-1);	}
		if( DBGF[8]>1) {
			fprintf(logfp, "ici(%d)ici2(%d)\n", ici, ici2 ) ;
			if( ici >= 0 ) {
				for ( i=(ici<ici2?ici:ici2)-1 ; i<=(ici>ici2?ici:ici2)+1 ; i++ ) {
					if ( i < 0 || i >= ga0->x_len ) continue ;
					fprintf(logfp, "(%d)  %d  %d\n",i,chrom_ko1[i], chrom_ko2[i] ) ;
				}
			}
		}
	}
	if( DBGF[6] ) { /*<<< 98/06*/
		CheckCr( chrom_ko1,ga0->x_len, ga0 ) ;
		CheckCr( chrom_ko2, ga0->x_len, ga0 ) ;
		//fprintf(logfp, "ko%d ici(%d)mae(%d)ato(%d)\n", i+1 ,ici, chrom_ko2[ici], val0) ; i+1ŗ
	}
	/* qF̂̃`FbN_ʂĂȂH TSPp */
	if( DBGF[10]>1) {
		chk_same_point_ga1(chrom_ko1, ga0->x_len, ga0->chk );
		chk_same_point_ga1(chrom_ko2, ga0->x_len, ga0->chk );
	}
	rc = 1; /* ˑRψق */
quit : if (DBGF[8]) fprintf(logfp, "<<< gaMUTAT rc(%d)\n",rc ) ;
	return( rc ) ;
}
/*	ID_gaCOPY_GCRO	 `qƓKx̃Rs[i͌j
********************************************************************/
static int gaCOPY_GCRO( //d, s )
	GCRO	*d,
	GCRO	*s)
{
	int 	*chrom;
	if( DBGF[20]) fprintf(logfp, "gaCOPY_GCRO >>> d(%x)s(%x)\n" );
	chrom = s->chrom;
	s->chrom = d->chrom;
	d->chrom = chrom;
	d->fitnes = s->fitnes;
	d->selsumi = 0;
	d->kai = s->kai ;	/* 98/08/24 */
	return(0);
}

/*	ID_gaIKINOKORI	 eォqփRs[
********************************************************************/
static int gaIKINOKORI( //with_repla, sharing, w_oya, w_ko, konum )
	int 	with_repla,
	int 	sharing,
	GCRO	*w_oya,
	GCRO	*w_ko ,
	int 	*konum,
	class GA1	*c)
{
	int 	i, i_ko ;
	if (DBGF[9]) fprintf(logfp, "gaIKINOKORI >>> with_repla(%d)sharing(%d)*konum(%d)\n",
					with_repla,sharing, *konum ) ;
/* eォq֕sKx̍ɃRs[ */
//	for( i = 0 ; i < c.x_ko ; ++i ) c.order[i] = i;
//	qsort( c.order, c.x_ko, sizeof(*c.order), QSORT_TYP oya_comp );
//	for( i = 0 ; *konum < c.x_ko ; ++(*konum), ++i	) {
//		i_ko = c.order[i] ; 		CHKA( 0,i_ko,c.x_ko);
//		if (DBGF[9]>1) fprintf(logfp, "i_ko(%d)\n",i_ko) ;
//		gaCOPY_GCRO( &w_ko[*konum], &w_oya[i_ko] );
//	}
	//for( i = 0 ; i < c->x_ko ; ++i ) c->order[i] = i;
	for( i = 0 ; i < c->x_ko ; ++i ) {
		c->sortwk[i].no = i; c->sortwk[i].fitnes = w_oya[i].fitnes; c->sortwk[i].selsumi = w_oya[i].selsumi;
	}
	//qsort( c->order, c->x_ko, sizeof(*c->order), QSORT_TYP oya_comp );
	qsort( c->sortwk, c->x_ko, sizeof(*c->sortwk), QSORT_TYP oya_comp );
	for( i = 0 ; *konum < c->x_ko ; ++(*konum), ++i	) {
		//i_ko = c->order[i] ; 		CHKA( 0,i_ko,c->x_ko);
		i_ko = c->sortwk[i].no ; 		CHKA( 0,i_ko,c->x_ko);
		if (DBGF[9]>1) fprintf(logfp, "i_ko(%d)\n",i_ko) ;
		gaCOPY_GCRO( &w_ko[*konum], &w_oya[i_ko] );
	}

/*quit :*/ if (DBGF[9]) fprintf(logfp, "<<< gaIKINOKORI rc(%d)\n",i) ;
	return( i );
}
/*	ID_gaINITMK	 𐶐
********************************************************************/
static int gaINITMK( //w_gcro, allele, len, popul_size )
	int 	**w_gcro ,
	int 	*allele ,
	int 	len,
	int		popul_size,
	class GA1 *ga0)
{
	int 	rc=0, i, j ;

	if (DBGF[11]) fprintf(logfp, "gaINITMK ===w_gcro(%lx)allele(%lx)len(%d)popul_size(%d)\n",w_gcro,allele,len, popul_size ) ;
	for ( i=0 ; i<popul_size ; i++ ) {
		for ( j=0 ; j<len ; j++ ) {
			w_gcro[i][j] = (int)(ga0->RANDsk( ) * allele[j]) ;
					CHKA(0,w_gcro[i][j],allele[j]);
		}
	}
	return( rc ) ;
}

/*	ID_dumpGCRO	
********************************************************************/
static int dumpGCRO( 
	char	*mes ,
	GCRO	*gcro,
	int 	nko  ,
	int 	nlen ,
	int 	elit )
{
	int 	k;
	fprintf(logfp,	mes, elit );
	for ( k=0 ; k<nko ; k++ ) {
		fprintf(logfp,	"fitnes(%e)prob(%lf)selsumi(%d)\n", gcro[k].fitnes,gcro[k].prob,gcro[k].selsumi) ;
		fprintf(logfp,	"[%d]chrom(",k ) ;
		PRINTDC( "", nlen, gcro[k].chrom );
	}
	return(0);
}
		//int xx[] = {1,2,3,4};

/*	ID_gaINITIAL	 *.def t@Cǂ܂ꂽp[^l̃`FbN
********************************************************************/
int gaINITIAL( //len )
	int 	len,
	class GA1	*ga0)
{
	int 	rc, i, j, ch, nn;
	ga0->x_ko	 = ga0->gap.popul_size ; 	CHKB(1,ga0->x_ko,ga0->x_ko);
	ga0->x_len	= len ;						CHKB(1,ga0->x_len,ga0->x_len);
	ga0->x_loop = ga0->gap.loop ;			CHKB(1,ga0->x_loop,ga0->x_loop);
	static int save_cross_count = -1;
									CHKB(1,ga0->gap.selec_type,3);
									CHKB(-1,ga0->gap.cross_count,len);
									CHKB(0,ga0->gap.elite_prsv,1);
									CHKB(0,ga0->gap.with_repla,1);
									CHKB(0,ga0->gap.sharing,1);
	if( ga0->gap.gener_gap < 1 || ga0->gap.gener_gap > ga0->x_ko ) ga0->gap.gener_gap = ga0->x_ko;
	if( ga0->gap.selec_type < 1 || ga0->gap.selec_type > 3 )	   goto err1;
	if( ga0->gap.cross_count <-1 || ga0->gap.cross_count >len)	 goto err1;
	if( ga0->gap.elite_prsv < 0 || ga0->gap.elite_prsv > 1 )	   goto err1;
	if( ga0->gap.with_repla < 0 || ga0->gap.with_repla > 1 )	   goto err1;
	if( ga0->gap.sharing	< 0 || ga0->gap.sharing	 > 1 )	   goto err1;
	if( ga0->gap.popul_size <= 0 )						   goto err1;
	if( ga0->x_len	<= 0 ) 							   goto err1;
	if( ga0->x_loop <= 0 ) 							   goto err1;
	if( ga0->gap.sharing == WITH_REPLA_OFF && ga0->gap.with_repla == SHARING_ON) goto err2;
	// ʑ1_܂͂Q_̂
	//test_many ŎsꍇAʑȍ~S cross_count = 2 ƂȂ͍̂̂ŁA
	//ύXO̒lۑĂāAC KS130909
//	if( ga0->gap.cross_typ == GA_TYP_PARTIALLY_MAPPED && (ga0->gap.cross_count != 1 && ga0->gap.cross_count != 2 )) {
//		fprintf(logfp,	"**** ʑ1_тQ_̂݁BȊO2_Ƃ܂\n" );
//		ga0->gap.cross_count = 2;
//	}
	if( ga0->gap.cross_typ == GA_TYP_PARTIALLY_MAPPED ) {
		if( ga0->gap.cross_count != 1 && ga0->gap.cross_count != 2 ) {
			save_cross_count = ga0->gap.cross_count;  //t@Cǂ񂾒lۑ
		fprintf(logfp,	"**** ʑ1_тQ_̂݁BȊO2_Ƃ܂\n" );
		ga0->gap.cross_count = 2;
	}
	} else {
		if( save_cross_count > 0 )  //ۑꂽl΁AC
			ga0->gap.cross_count = save_cross_count;
	}
#ifdef Z0 // MAIN̂Ƃֈړ 2015.11.30 YS
	nn = sizeof(*DBGF_init) / sizeof(DBGF_init[0]);  //NT130821 _
#endif
	nn = DBGF_init_size();
	j  = 0;
	if( ga0->gap.trace )
		for( i = 0 ; ga0->gap.trace[i] ; ++i ) {  //NT130213chg
			ch = ga0->gap.trace[i];
			if( ch >= '0' && ch <= '9' ) DBGF[j++] = ch - '0';
			if( j >= nn ) break;  //NT130213add
		}
	for( ; j < nn ; ++j )
		DBGF[j] = DBGF_init[j];
#ifdef Z0 // MAIN̂Ƃֈړ 2015.11.30 YS
	nn = sizeof(*DBGF)/ sizeof(int);                  //NT130821 _
#endif
	nn = DBGF_size();

	for( ; j < nn; ++j )
		DBGF[j] = 0;

	rc = 0;
quit: return( rc );
err1: rc = -1;
	goto							quit;
err2: rc = -2;
	fprintf(logfp,	"**** 񕜌oƃVFAO͓wo܂B\n" );  fflush(logfp); //KS130918 fflush ǉ
	goto							quit;
}
static void * Xalloc( //num, size )
	unsigned int 	num,
	unsigned int 	size)
{
	return( calloc( num, size ) );
}
void Xfree( //ptr )
	void	*ptr)
{
	free( ptr );
	return;
}

/*	ID_gaALLOC	 GÃAP[g
********************************************************************/
int gaALLOC( //popul_size, len )
	class GA1 *ga0)
//	int 	popul_size,
//	int 	len )
{
	int 	rc=0, i ;
//	if (DBGF[8]) fprintf(logfp, "gaALLOC >>> popul_size(%d)len(%d)\n",popul_size, len ) ;
//	ga0->oya_gcro = ga0->ko_gcro = NULL;
//	ga0->kousa = ga0->order = ga0->taro_gcro.chrom = ga0->hana_gcro.chrom = NULL;
//	ga0->intgcro = NULL;
//	ga0->sawkval = NULL ;		/*98/06*/
//	ga0->sawkkousa = NULL ;	/*98/06*/
//	ga0->edgelist = NULL;
//test_many ŎsƁÄ邱ƂȂÅ֐xĂ΂Ă܂̂ŁA
//Qxڈȍ~ɌĂ΂ꂽƂ́AAP[gȂŖ߂B
	if( ga0->oya_gcro != 0 ) goto                         quit;  //KS130909add
	if((ga0->oya_gcro        = (GCRO*)Xalloc(ga0->x_ko, sizeof(GCRO))) == NULL ) goto err1;
	if((ga0->ko_gcro         = (GCRO*)Xalloc(ga0->x_ko, sizeof(GCRO))) == NULL ) goto err1;
	if((ga0->taro_gcro.chrom = (int*)Xalloc(ga0->x_len, sizeof(int)))  == NULL ) goto err1 ;
	if((ga0->hana_gcro.chrom = (int*)Xalloc(ga0->x_len, sizeof(int)))  == NULL ) goto err1 ;
	if((ga0->sortwk = (struct gcrowk_st *)Xalloc( ga0->x_ko, sizeof(*ga0->sortwk))) == NULL ) goto err1; // 13.05.09 YS
	for( i=0 ; i<ga0->x_ko ; i++ )	{
		if((ga0->oya_gcro[i].chrom=(int*)Xalloc(ga0->x_len, sizeof(int))) == NULL ) goto err1 ;
		if((ga0->ko_gcro[i].chrom =(int*)Xalloc(ga0->x_len, sizeof(int))) == NULL ) goto err1 ;
		if((ga0->sortwk[i].chrom  =(int*)Xalloc(ga0->x_len, sizeof(int))) == NULL ) goto err1 ;
	}
	if((ga0->kousa     = (int*)Xalloc( ga0->x_len, sizeof(*ga0->kousa)))      == NULL ) goto err1;
	if((ga0->order     = (int*)Xalloc( ga0->x_ko, sizeof(*ga0->order)))       == NULL ) goto err1;
	if((ga0->sawkval   = (int*)Xalloc( ga0->x_len, sizeof(*ga0->sawkval)))    == NULL ) goto err1;			/*98/06*/
	if((ga0->sawkkousa = (int*)Xalloc( ga0->x_len, sizeof(*ga0->sawkkousa)))  == NULL ) goto err1;	/*98/06*/
	if((ga0->edgelist2  = (int*)Xalloc( ga0->x_len*5, sizeof(*ga0->edgelist2))) == NULL ) goto err1;	/*15.05.23*/
	if((ga0->edgelist  = (struct edgelist_st*)Xalloc( ga0->x_len, sizeof(struct edgelist_st))) == NULL )     goto err1;	/*15.05.18*/
	if ((ga0->intgcro  = (int**)Xalloc( ga0->x_ko, sizeof(int*)))             == NULL ) goto err1 ;
	for( i=0 ; i<ga0->x_ko ; i++ ) ga0->intgcro[i] = ga0->oya_gcro[i].chrom ;
	//if((ga0->chk = (int*)Xalloc( ga0->x_len, sizeof(*ga0->chk))) == NULL ) goto err1; // TSP _̏dCHKp 12.01.09 //tspINIT()Ŋmۍ 15.06.29YS
	memset( ga0->chk, 0, ga0->x_len * sizeof(*ga0->chk)) ;
quit:
	if (DBGF[8]) fprintf(logfp, "<<< gaALLOC rc(%d)\n",rc) ;
	return( rc ) ;
err1 : fprintf(logfp, "**** Xalloc error \n") ;  fflush(logfp); //KS130918 fflush ǉ
	/*exit( 1 ) ;*/
	return(-1) ;
}
/*
/* AP[gGẢ
/* */
#ifdef Z0 // fXgN^[ɕύX
// int gaFINAL( )
int gaFINAL( class GA1 *ga0 )
{
	int 	rc=0, i;

	if (DBGF[9]) fprintf(logfp, "gaFINAL >>>\n") ;
	if( ga0->ans ) free( (char*)ga0->ans ), ga0->ans = NULL;
	if( ga0->allele ) free( (char*)ga0->allele ), ga0->allele = NULL;
	if( ga0->rank ) free( (char*)ga0->rank ), ga0->rank = NULL;
	if( ga0->sagyo ) free( (char*)ga0->sagyo ), ga0->sagyo = NULL;
	if( ga0->mcn ) free( (char*)ga0->mcn ), ga0->mcn = NULL;
	if( ga0->chk ) free( (char*)ga0->chk ), ga0->chk = NULL;
	if( ga0->route_num ) free( (char*)ga0->route_num ), ga0->route_num = NULL;
	if( ga0->xy_cost ) free( (char*)ga0->xy_cost ), ga0->xy_cost = NULL;

	if( ga0->oya_gcro ) {
		for (i=0 ; i<ga0->x_ko ; i++ )
			if( ga0->oya_gcro[i].chrom ) Xfree( (char*)ga0->oya_gcro[i].chrom ) ;
		Xfree( (char*)ga0->oya_gcro ), ga0->oya_gcro = NULL ;
	}
	if( ga0->ko_gcro ) {
		for (i=0 ; i<ga0->x_ko ; i++ )
			if( ga0->ko_gcro[i].chrom ) Xfree( (char*)ga0->ko_gcro[i].chrom ) ;
		Xfree( (char*)ga0->ko_gcro ), ga0->ko_gcro = NULL ;
	}
	if( ga0->taro_gcro.chrom ) Xfree( (char*)ga0->taro_gcro.chrom ), ga0->taro_gcro.chrom = NULL;
	if( ga0->hana_gcro.chrom ) Xfree( (char*)ga0->hana_gcro.chrom ), ga0->hana_gcro.chrom = NULL;
	if( ga0->kousa ) Xfree( (char*)ga0->kousa ), ga0->kousa = NULL ;
	if( ga0->order ) Xfree( (char*)ga0->order ), ga0->order = NULL ;
	if( ga0->sawkval ) Xfree( (char*)ga0->sawkval ), ga0->sawkval = NULL ;				/*98/06*/
	if( ga0->sawkkousa ) Xfree( (char*)ga0->sawkkousa ), ga0->sawkkousa = NULL ;	/*98/06*/
	if( ga0->edgelist ) Xfree( (char*)ga0->edgelist ), ga0->edgelist = NULL ;	/*13/02*/
	if( ga0->intgcro ) Xfree( (char*)ga0->intgcro ), ga0->intgcro = NULL ;
	if( ga0->chk ) Xfree( (char*)ga0->chk ), ga0->chk = NULL ;
	if( edge ) Xfree( (char*)edge ), edge = NULL ;
	if (DBGF[9]) fprintf(logfp, "<<< gaFINAL\n") ;
	return( rc ) ;
}
#endif // fXgN^[ɕύX
/*
/* ֐rand( )̏lݒ
/* */
int GA1::RANDinit( )
{
	int 	i ;
#ifdef _WIN32
	srand( 1 ) ;
#else	/* unix */
	srand48( 0L ) ;
#endif
	for( i=0 ; i<100 ; i++ ) RANDsk( );
	return(0) ;
}
/*	ID_GA1::RANDsk	 ͈[0.0, 1.0)̊Ԃŗ𔭐
********************************************************************/
 double GA1::RANDsk( )
{
	register double	dval;
	double	drand48() ;
	static int 	initflag = 0;

	if( ! initflag ) {
		max_val = 0.0; min_val = 1.0;
		initflag = 1;
		RANDinit();
	}
#ifdef _WIN32
	dval =	(double)rand()/(1.0+(double)RAND_MAX) ;
#else	/* unix */
	dval = drand48( ) ; /*  [0.0, 1.0)  lz񕉂̔{x_lԂB */
#endif
	if ( dval > max_val ) max_val = dval ;
	if ( dval < min_val ) min_val = dval ;
	return( dval ) ;
}

/*---------------------> 1998/06ǉ*/
/* lvalibuf[]̒Ɋ܂܂邩? 1:܂ 0:܂܂Ȃ*/
 int IsInclude(  //fobN̂ݎgp
	int val,		/*i l */
	int *ibuf,		/*i TW */
	int ibufCount)	/*i ibuf[]̔z */
{
//	int *w1 = ibuf ;
//	int *wend = &ibuf[ibufCount-1] ;
//	for( ; w1 <= wend && val != *w1 ; w1++ ) ;
//						//CHKB(ibuf, w1, wend+sizeof(*ibuf)) ;BoundChecker ŃG[ɂȂ̂ŁAC
//						CHKB(0, w1 - ibuf, ibufCount);
//	return( (char*)w1 <= (char*)wend ) ;
	int i;
	for( i = 0; i < ibufCount; ++i )
		if( ibuf[i] == val ) break;
	return (i < ibufCount);
}
/* lvalibuf[]̒Ɋ܂܂邩? >=0:܂ށïʒujibufCount:܂܂Ȃ 2012.12.21 */
 int IsInclude2(  //gp
	int val,		/*i l */
	int *ibuf,		/*i TW */
	int ibufCount)	/*i ibuf[]̔z */
{
	int i ;
	for( i = 0; i < ibufCount; i++ ) {
		if( ibuf[i] == val) break;
	}
						CHKB(0, i, ibufCount) ;
	return(i ) ;
}

/*Debug*/
 void DebugChrom(
	int num, 			/* sawkvaľ */
	int numKousa,		/* aKousa[]̔z */
	int aKousa[],		/* tO[]=1̎ */
	int srcOya[],		/* eP̔z */
	int dsnOya[],		/* eQ̔z */
	int dsnChild[],		/* q̔z */
	class GA1 *ga0)
{
	int i ;
	fprintf(logfp, "***Chrom***\nsawkval(%d)\n",num) ;
	for ( i=0 ; i<num ; i++ ) fprintf(logfp, "(%d)%d%c",i, ga0->sawkval[i],((i+1)%10?' ':'\n') ) ;
	fprintf(logfp, "\n     wkkousa( ) oya1 oya2  child\n") ;
	for ( i=0 ; i<numKousa ; i++ )
	fprintf(logfp, "(%03d)      %d(%d) %-4d %-4d%c  %d%c\n"
	,i, ga0->sawkkousa[i], aKousa[i], srcOya[i], dsnOya[i], (IsInclude( dsnOya[i], ga0->sawkval, num )?'*':' '),dsnChild[i], (dsnOya[i]-dsnChild[i]?'*':' ') ) ;
	fflush(logfp);
}

/*	ID_CrossNormalr	
********************************************************************/
static int CrossNormal( //ɂOԂ
	int numKousa,	/*i aKousa[]̔z */
	int *aKousa,	/*i tO[]=1̎ */
	int *srcOya,	/*i eP̔z */
	int *dsnOya,	/*i eQ̔z */
	int *dsnChild,	/*o ePƐeQłq */
	class GA1 *ga0)
{
	int i;
	if ( ga0->gap.locus_unique ) { //1:`qƂɂƂ肤`qقȂB
		for( i = 0 ; i < ga0->x_len ; i++ ) { //Ȃ
			dsnChild[i] = srcOya[i];
		}
	} else {
		for( i = 0 ; i < ga0->x_len ; i++ ) {
			dsnChild[i] = (aKousa[i]) ? srcOya[i] : dsnOya[i];
		}
	}
	return(0) ;
}
/*	ID_CrossOrder ^ ɊÂ(Order-based crossover) 98/06/18
/* eQqǂ쐬
/* Iꂽʒu(3,4,6,9)̐eQ̒l(2,8,6,5)ƓleP̈ʒu(2,5,6,8)߁A
/* eQ̒l̕я(2,8,6,5)ƓɕтB*/
/* p1=(123456789)	-> (2865) c1=(1*34**7*9)	-> (2865𖄂߂) c1=(123486759)
   p2=(412876935)	-> (3469) c2=(*1287***5)	-> (3469𖄂߂) c2=(312874695)
		 || |  |  3,4,6,9ԂI
********************************************************************/
static int CrossOrder(
	int numKousa,	/*i aKousa[]̔z */
	int *aKousa,	/*i tO[]=1̎ */
	int *srcOya,	/*i eP̔z */
	int *dsnOya,	/*i eQ̔z */
	int *dsnChild,	/*o ePƐeQłq */
	class GA1 *ga0)

{
	int num=0;
	int i, imax, idx, k;
	//static int CrossOrder_count = 0; // fobOp
	/* ͐ẽ`FbN@_ʂĂȂH */
	if ( DBGF[10]) {
		chk_same_point_ga1(srcOya,numKousa, ga0->chk );
		chk_same_point_ga1(dsnOya,numKousa, ga0->chk );
	}
	//CrossOrder_count++;
	//if( CrossOrder_count == 20 ) {
	//	CrossOrder_count =	CrossOrder_count;
	//}
	//if ( DBGF[8]) fprintf(logfp, "CrossOrder No(%d)\n",CrossOrder_count) ;
	for ( i=0 ; i<numKousa ; i++ ) {
		ga0->sawkkousa[dsnOya[i]] = i;
		dsnChild[i] = dsnOya[i];
	}
	imax = 0;
	for ( i = num = 0 ; i<numKousa ; i++ ) {
		if ( aKousa[i] ) {
			idx = ga0->sawkkousa[srcOya[i]];  CHKA(0, idx, numKousa);
			ga0->sawkval[num++] = srcOya[i] ;
			dsnChild[idx] = -1;
			if( idx > imax ) imax = idx;
		}
	}
	if( num == numKousa ) {
		memcpy( dsnChild, ga0->sawkval, numKousa * sizeof(*ga0->sawkval) ) ;
	} else {
		++imax;
		for(k = i = 0; i < imax; i++) { 
			if( dsnChild[i] < 0 ) 
				dsnChild[i] = ga0->sawkval[k++];
		}														CHKB(k, num, k);
	}
	//for ( i=0 ; i<numKousa ; i++ ) ga0->sawkkousa[i] = 0;
	if ( DBGF[8]) DebugChrom( num, numKousa, aKousa, srcOya, dsnOya, dsnChild, ga0 ) ;
	/* q̃`FbN_ʂĂȂH */
	if ( DBGF[10]) chk_same_point_ga1(dsnChild,numKousa,ga0->chk );

	return( 0 ) ;
}

/*	ID_CrossPosition	ʒu^ ʒuɊÂ(Position-based crossover) 98/06/18
/* eQqǂ쐬
/* Iꂽʒu̐eP̒l߰B߰ePƓleQ珜OāA󂢂ĂʒuɐeQZbgB*/
/* p1=(ABCDEFGH)   -> (246Ԃc) c1=(*B*D*F**)  -> (cp2珇ۑăRs[) c1=(HBGDEFCA)
   p2=(HGFEDCBA)   -> (246Ԃc) c2=(*G*E*C**)  -> (cp1珇ۑăRs[) c2=(AGBEDCFH)
		| | |	 2,4,6ԂI
********************************************************************/
static int CrossPosition(
	int numKousa,		/*i aKousa[]̔z */
	int aKousa[],		/*i tO[]=1̎ */
	int srcOya[],		/*i eP̔z */
	int dsnOya[],		/*i eQ̔z */
	int dsnChild[],		/*o ePƐeQłq */
	class GA1 *ga0)
{
	int i, idx, k, imax, num=0 ;

	//eQ̃CfNXۑ
//fprintf(logfp,"numKousa=%d\n",numKousa ) ; fflush(logfp);
//for ( i=0 ; i<numKousa ; i++ ) fprintf(logfp, "%d	", aKousa[i]); fprintf(logfp,"\n" ) ; fflush(logfp);
//for ( i=0 ; i<numKousa ; i++ ) fprintf(logfp, "%d	", srcOya[i]); fprintf(logfp,"\n" ) ; fflush(logfp);
//for ( i=0 ; i<numKousa ; i++ ) fprintf(logfp, "%d	", dsnOya[i]); fprintf(logfp,"\n" ) ; fflush(logfp);
	for ( i=0 ; i<numKousa ; i++ ) {
		idx = dsnOya[i] ;  CHKA(0, idx, numKousa);
		ga0->sawkkousa[idx] = i;
//fprintf(logfp,"%d)%d ",idx, i ) ; fflush(logfp);
	}
//fprintf(logfp,"\n" ) ; fflush(logfp);
	//Iꂽʒu̐eP̒l߰BeQ̔zł́A߰ꂽl̃CfNX𕉂ɂ
	imax = numKousa - 1 ;
	for(i = 0; i < numKousa; i++) {
		if ( aKousa[i] ) {
			idx = srcOya[i];  CHKA(0, idx, numKousa);
			ga0->sawkkousa[idx] = -1;
			dsnChild[i] = idx;
			imax = i;
			if ( DBGF[8]) ga0->sawkval[num++] = srcOya[i] ; //fobOvgp
		}
	}
	imax = numKousa - 1 ; //HPC(c)  for test
	//ceQ̔z񂩂珇ۑăRs[
	for(k = i = imax + 1; ; k++) { 
		if( k >= numKousa ) k = 0;  CHKA(0, k, numKousa);
		idx = dsnOya[k];            CHKA(0, idx, numKousa);
		if( ga0->sawkkousa[idx] >= 0 ) { //Rs[ς݂łȂ
			for( ; ; ++i ) {
				if( i >= numKousa ) i = 0;
				if ( aKousa[i] == 0 ) break;
			}                       CHKA(0, i, numKousa);
			dsnChild[i++] = idx;
		}
		if( k == imax ) break;
	}
	if ( DBGF[8]) DebugChrom( num, numKousa, aKousa, srcOya, dsnOya, dsnChild , ga0 ) ;
	/* q̃`FbN_ʂĂȂH */
	if ( DBGF[10]) chk_same_point_ga1(dsnChild,numKousa,ga0->chk );
	return( 0 ) ;
}

/*	ID_CrossMapped	ʑ^(PMX:Partially-mapped crossover) 2012.12.21
   eQqǂ쐬
   IꂽiQ_Ԃ̕j͐eQ̒l(1,8,7,6)߰BȊO͐̕ePRs[B
   dȂl(1,8)͐eQRs[ʒu([4],[5])̏ɂ̂ŐeP̌̒l(4,5)dȂʒuɃRs[
   p1=(123|4567|89)   ->   c1=(***|1876|**)  ->   c1=(*23|1876|*9)	->	 c1=(423|1876|59)
   p2=(452|1876|93)   ->   c2=(***|4567|**)  ->   c2=(**2|4567|93)	->	 c2=(182|4567|93)
********************************************************************/
static int CrossMapped(
	int numKousa,		/*i aKousa[]̔z */
	int aKousa[],		/*i tO[]=1̎ */
	int srcOya[],		/*i eP̔z */
	int dsnOya[],		/*i eQ̔z */
	int dsnChild[],		/*o ePƐeQłq */
	class GA1 *ga0)
{
	int i, bi, pos ;

	for ( i=0 ; i<numKousa ; i++ ) {
		bi = dsnOya[i]; 				 CHKA(0, bi, numKousa);
		ga0->sawkval[bi] = i;
	}
	/* IꂽiQ_Ԃ̕j͐eQ̒l߰B*/
	for ( i=0 ; i<numKousa ; i++ ) {
		if( aKousa[i] ) {
			dsnChild[i] = dsnOya[i];
		} else {
			/* IꂽiQ_Ԃ̕jȊOŏdȂ镔͐Vl */
			bi = srcOya[i]; 			 CHKA(0, bi, numKousa);
			while(1) {
				pos = ga0->sawkval[bi]; //eQ̔zdsnOya[]łbïʒu
										 CHKA(0, pos, numKousa);
				if( aKousa[pos] == 0 ) break;
				bi = srcOya[pos];
			}
			dsnChild[i] = bi;
		}
	}
	if ( DBGF[8]) DebugChrom( numKousa, numKousa, aKousa, srcOya, dsnOya, dsnChild, ga0 ) ;
	/* q̃`FbN_ʂĂȂH */
	if ( DBGF[10]) chk_same_point_ga1(dsnChild,numKousa,ga0->chk );
	return( 0 ) ;
}

/*	ID_CrossCyclic	z^(CX:Cyclic crossover) 2013.01.15
/* e1qǂ쐬AceQRs[
/* eP̐擪ZbgAe2̐擪wĂ鐔lZbgÄʒu̐e2̒lePZbgEEEBc͐e2̂̂̂܂܃Rs[
/* p1=(123456789) -> c1=(1********) -> c1=(1**4*****) -> c1=(1**4***8*) -> c1=(1*34***8*) -> c1=(1234***8*) ->(cZbg) c1=(123476985)
   p2=(412876935) -> c2=(4********) -> c2=(41*******) -> c2=(412******) -> c2=(412****3*) -> c2=(4128***3*) ->(cZbg) c2=(412856739)
********************************************************************/
static int CrossCyclic(
	int numKousa,		/*i aKousa[]̔z */
	int aKousa[],		/*i tO ֌WȂ*/
	int srcOya[],		/*i eP̔z */
	int dsnOya[],		/*i eQ̔z */
	int dsnChild[],		/*o ePƐeQłq */
	class GA1 *ga0)
{
	int i, pos, num, num0;

	// 
	for(i = 0; i < numKousa; i++ ) {
		dsnChild[i] = dsnOya[i];						CHKA(0,srcOya[i],numKousa);
		ga0->sawkkousa[srcOya[i]] = i;
	}
	/* e1̐擪Zbg */
	dsnChild[0] = srcOya[0];
	/* eQ̐擪̐lZbg */
	num = num0 = dsnOya[0];								CHKA(0,num,numKousa);
	pos = ga0->sawkkousa[num];							CHKA(0,pos,numKousa);
	/* zĐeP̒lZbg */
	while( dsnOya[pos] != num0 ) {        
		dsnChild[pos] = num;
		num = dsnOya[pos];								CHKA(0,num,numKousa);
		pos = ga0->sawkkousa[num];						CHKA(0, pos, numKousa);
	}

	if ( DBGF[8]) DebugChrom( numKousa, numKousa, aKousa, srcOya, dsnOya, dsnChild, ga0 ) ;
	/* q̃`FbN_ʂĂȂH */
	if ( DBGF[10]) chk_same_point_ga1(dsnChild,numKousa,ga0->chk );
	return( 0 ) ;
}
/*	ID_edgelist_print	edgelist[] ó@fobOp
********************************************************************/
int	edgelist_print(
 int	numKousa,
 struct edgelist_st *edgelist)
{
	int		i, j;
	fprintf(logfp,"*** edgelist[] ***\n");
	for( i = 0; i < numKousa; i++ ) {
		fprintf(logfp,"%d) ",i);
		for( j = 0; j < 4; j++ ) {
			fprintf(logfp,"%d ", edgelist[i].oya[j]);
		}
		fprintf(logfp,"%d ", edgelist[i].num);
		fprintf(logfp,"\n ");
	}
	fflush(logfp);
	return(0);
}

/*	ID_edgelist2_print	edgelist2[] ó@fobOp
********************************************************************/
int	edgelist2_print(
 int	numKousa,
 int	*edgelist2)
{
	int		i, j;
	fprintf(logfp,"*** edgelist2[] ***\n");
	for( i = 0; i < numKousa; i++ ) {
		fprintf(logfp,"%d) ",i);
		for( j = 0; j < 5; j++ ) {
			fprintf(logfp,"%d ", edgelist2[i*5+j]);
		}
		fprintf(logfp,"\n ");
	}
	fflush(logfp);
	return(0);
}

/*	ID_ment_edgelist	Sedgelist[]炘
********************************************************************/
static int	ment_edgelist(
	int	x,
	int	numKousa,
	struct edgelist_st	*edgelist)
{
	int		i,j, num, y1, rc = 0;

	// xedgexgĂss̃Xge
	for( j = 0; j < edgelist[x].num; j++ ) {
		if( (y1 = edgelist[x].oya[j]) < 0 ) y1 =-y1;    CHKA(0,y1,numKousa);
		num = edgelist[y1].num;   CHKB(0,num,4);
		for( i = 0; i < num; i++ ) {
			if( edgelist[y1].oya[i] == x || edgelist[y1].oya[i] == -x ) {
				if( i != num -1 )  edgelist[y1].oya[i] = edgelist[y1].oya[num-1]; 
				edgelist[y1].oya[num-1] = numKousa; // Ōォ
				edgelist[y1].num--;
				break;
			}
		}
		CHKA(0,i,num); // Ή郊Xgɂ͂͂
		edgelist[x].oya[j] = numKousa;
	}
	edgelist[x].num = 0;
	return(rc);
}

/*	ID_CrossEdgeRecomb	Ӎđg(ER:Edge Recombination crossover) 2013.01.30
/* e1AeQAessɗאڂӂ̃XgB
/* ŏ̓ssPIԁiCӁjB̓ssɗאڂssōŏ̕ӂ̐iss̐jssIԁB
/* CӂɑIԁB̑JԂB
/* ssXgɋĂƂ́A̓ssɂ͗D挠^Bi|t^j
/* e p1=(123456789) p2=(412876935)@ƂƂאڂss̃Xg
/* ss1: 9,2,4   -> 9,-2,4
/* ss2: 1,3,8   -> -1,3,8
/* ss3: 2,4,5,9
/* ss4: 1,3,5   -> 1,3,-5
/* ss5: 3,4,6   -> 3,-4,6
/* ss6: 5,7,9   -> 5,-7,9
/* ss7: 6,8	  -> -6,-8
/* ss8: 2,7,9   -> 2,-7,9
/* ss9: 1,3,6,8
/*
/* ss1n܂ꍇ
/* c1=(128765439)
/* ssQn܂ꍇ
/* c1=(214567893)
/* ssRn܂ꍇ
/* c1=(321456789)
/* c1=(345678219)
/* c1=(354128769)
/* ssSn܂ꍇ
/* c1=(456782193)
/* ssTn܂ꍇ
/* c1=(541287693)
/* ssUn܂ꍇ
/* c1=(678214539)
/* ssVn܂ꍇ
/* c1=(765412893)
/* c1=(782145693)
/* ssWn܂ꍇ
/* c1=(876541239)
/* ssXn܂ꍇ
/* c1=(912876543)
/* c1=(967821453)
/* c1=(987654123)
********************************************************************/
static int CrossEdgeRecomb(
	int numKousa,		/*i aKousa[]̔z */
	int aKousa[],		/*i tO ֌WȂ*/
	int srcOya[],		/*i eP̔z */
	int dsnOya[],		/*i eQ̔z */
	int dsnChild[],		/*o ePƐeQłq */
	class GA1 *ga0)
{
	int i, pos, num, x,x1,x2, y1, y2, yy, yyy, j, min, cnt, cnt1;

	/* ͐ẽ`FbN@_ʂĂȂH */
	if ( DBGF[10]) {
		chk_same_point_ga1(srcOya,numKousa,ga0->chk );
		chk_same_point_ga1(dsnOya,numKousa,ga0->chk );
	}
	// 
	//for(i = 0; i < numKousa; i++ ) {		dsnChild[i] = -1;	}
	//for(i = 0; i < numKousa*5; i++ ) {		ga0->edgelist[i] = -1;	}
	/* edgelist̍쐬 */
	/* ssedgelistւ̃ZbǵAedgelist[x].oya[0]:eP̑O̓ssA[1]:eP̌̓ss
									 edgelist[x].oya[2]:eQ̑O̓ssA[3]:eQ̌̓ssƂ
									 edgelist[x].num:Xg̓ss
									 ܂AdȂƂ́[t^ ss͌炷*/
	for(i = 0; i < numKousa; i++ ) {
		ga0->sawkkousa[i] = -1;
		dsnChild[i] = -1;
		x1= srcOya[i];	CHKA(0,x1,numKousa);
		x2= dsnOya[i];	CHKA(0,x2,numKousa);
		if( i == 0 )			{ ga0->edgelist[x1].oya[0] = srcOya[numKousa-1];	ga0->edgelist[x2].oya[2] = dsnOya[numKousa-1];	}
		else					{ ga0->edgelist[x1].oya[0] = srcOya[i-1];			ga0->edgelist[x2].oya[2] = dsnOya[i-1];  }
		if( i == numKousa-1 )	{ ga0->edgelist[x1].oya[1] = srcOya[0];				ga0->edgelist[x2].oya[3] = dsnOya[0]; }
		else					{ ga0->edgelist[x1].oya[1] = srcOya[i+1];			ga0->edgelist[x2].oya[3] = dsnOya[i+1]; }
	}	
	// _uss̃e@@dȂss̗ɂ͂l`wĂiȂ@fobOpj
	for(x = 0; x < numKousa; x++ ) {
		for( i = 0, cnt = 0; i < 4; i++ ) if( ga0->edgelist[x].oya[i] >= 0 ) cnt++;
		ga0->edgelist[x].num = cnt;	   CHKB(4,cnt,4);// ssS
		if( ga0->edgelist[x].oya[0] == ga0->edgelist[x].oya[2] ) {
			ga0->edgelist[x].oya[0] *= -1; ga0->edgelist[x].oya[2] = numKousa; ga0->edgelist[x].num--;
		}
		else if( ga0->edgelist[x].oya[0] == ga0->edgelist[x].oya[3] ) {
			ga0->edgelist[x].oya[0] *= -1; ga0->edgelist[x].oya[3] = numKousa; ga0->edgelist[x].num--;
		}
		if( ga0->edgelist[x].oya[1] == ga0->edgelist[x].oya[2] ) {
			ga0->edgelist[x].oya[1] *= -1; ga0->edgelist[x].oya[2] = numKousa;	ga0->edgelist[x].num--;
		}
		else if( ga0->edgelist[x].oya[1] == ga0->edgelist[x].oya[3] ) {
			ga0->edgelist[x].oya[1] *= -1; ga0->edgelist[x].oya[3] = numKousa;	ga0->edgelist[x].num--;
		}
		if( ga0->edgelist[x].num == 3 && ga0->edgelist[x].oya[2] == numKousa ) {
			ga0->edgelist[x].oya[2] = ga0->edgelist[x].oya[3]; ga0->edgelist[x].oya[3] = numKousa;
		}
		CHKB( 2,ga0->edgelist[x].num,4);
	}
//	if(DBGF[8]>0) {edgelist_print(numKousa,ga0->edgelist);}
	/* q̐擪߂ */
	pos = (int)(ga0->RANDsk() * numKousa);	 CHKA(0,pos,numKousa);
	dsnChild[0] = x = srcOya[pos];
	ga0->sawkkousa[x] = 0;
	for( i = 1; i < numKousa; i++ ) {
		/* edgelist[]炘 */
		//ment_edgelist(x, numKousa);
		/* edgelist[]A̓ssI */
		/* [i}CiXjt^̓ss炻D */ /* -̂edgelist[x].oya[0]edgelist[x].oya[1] */
		if( (y1 = ga0->edgelist[x].oya[0])  < 0 && ga0->edgelist[-y1].num > 0 ) {
			if((y2 = ga0->edgelist[x].oya[1]) < 0 && ga0->edgelist[-y2].num > 0 ) { // QƂ[ȂCӂɑI
				pos = (int)(ga0->RANDsk() * 2);	  CHKA(0,pos,2);
				dsnChild[i] = ga0->edgelist[x].oya[pos] * -1;
			}
			else {
				dsnChild[i] = ga0->edgelist[x].oya[0] * -1; // y1
			}
		}
		else if((y2 = ga0->edgelist[x].oya[1]) < 0 && ga0->edgelist[-y2].num > 0 ) {
			dsnChild[i] = ga0->edgelist[x].oya[1] * -1;  // y2
		}
		else { /* -t^͂Ȃאړss͑I */ /* ӂ̐Ȃ̂I */
			num = ga0->edgelist[x].num;
			min = 4; yy = -1; cnt = 0;
			for( j = 0; j < num; j++ ) {
				y1 = ga0->edgelist[x].oya[j];
				if( y1 < 0 ) y1 = -y1;
				//if( edgelist[y1].num > 0 && (yy == -1 || edgelist[y1].num < min) ) {
				if((yy == -1 || ga0->edgelist[y1].num < min) ) {
					min = ga0->edgelist[y1].num; cnt = 1; yy = y1;
				}
				else if( ga0->edgelist[y1].num == min ) cnt++;
			}
			if( cnt > 1 ) { /* ӂ̐̂ */
				pos =  (int)(ga0->RANDsk() * cnt);
				for( j = 0, cnt1 = 0, yy = -1; j < num; j++ ) { /*???*/
					y1 = ga0->edgelist[x].oya[j];
					if( y1 < 0 ) y1 = -y1;
					if( ga0->edgelist[y1].num == min ) {
						if( cnt1 == pos ) { yy = y1; break;}
						cnt1++;
					}
				}CHKA(0,yy,numKousa);
			}
			else if( cnt == 0 ) {// łɗאڂss͑Iρ@@cĂss烉_ɑIԁ@iłHj
				/*do {
				/*	yy = (int)(RANDsk() * numKousa);	CHKA(0,yy,numKousa);
				/*}while((pos = IsInclude2( yy, dsnChild, i )) < i);
				 Ԃ肷邽ߕύX  N__Ȃł̂Ƃ̓V[PVT[` */

				yy = yyy =	(int)(ga0->RANDsk() * numKousa);	CHKA(0,yy,numKousa);
				for( ; yy < numKousa; yy++) {
					if( ga0->sawkkousa[yy] < 0 ) break;
				}
				if( yy >= numKousa ) {      //yy`numKousa-1 ̒l dsnChild[] ɂ݂
					for(yy = yyy; yy >= 0; yy--) {
						if( ga0->sawkkousa[yy] < 0 ) break;
					}
				}
			}
			else {// cnt=1͂yyg
			}
			//CHKB(1,cnt,4);
			CHKA(0,yy,numKousa);
			//pos = IsInclude2( yy, dsnChild, i ); CHKB(i,pos,i); //܂łɓo^Ȃ͂ // mߎẐ߃Rg 130208YS
			dsnChild[i] = yy;
		}
		/* edgelist[]炘 */
		ment_edgelist(x, numKousa,ga0->edgelist);

		x = dsnChild[i];   CHKA(0,x,numKousa);
		ga0->sawkkousa[x] = i;
		if ( DBGF[8]>0) fprintf(logfp,"dsnChild[%d]=%d\n",i,x ) ; fflush(logfp);
	}

	if ( DBGF[8]>0) DebugChrom( numKousa, numKousa, aKousa, srcOya, dsnOya, dsnChild, ga0 ) ;
	/* q̃`FbN_ʂĂȂH */
	if ( DBGF[10]>0) chk_same_point_ga1(dsnChild,numKousa,ga0->chk );
	return( 0 ) ;
}
/*	ID_CrossSeqConstruct	
  (Sequential Constructive Crossover:SCX)
	Ahmed, Zakir H. "Genetic Algorithm for the Traveling Salesman Problem Using Sequential Constructive Crossover Operator."
	International Journal of Biometric and Bioinformatics 3.6 (2010). Computer Science Journals.
	Web. <http://www.cscjournals.org/csc/manuscript/Journals/IJBB/volume3/Issue6/IJBB-41.pdf>.
	RXg\sagyo[][]gAZIڂƂĂB
	Q̐eQ̎q͍ꂸAP̎qȂBoss𗐐΂Q邩B
	mTspɂ͌Ȃ
********************************************************************/
static int CrossSeqConstruct(
	int numKousa,		/*i aKousa[]̔z */
	int aKousa[],		/*i tO ֌WȂ*/
	int srcOya[],		/*i eP̔z */
	int dsnOya[],		/*i eQ̔z */
	int dsnChild[],		/*o ePƐeQłq */
	class GA1 *ga0)
{
	int		i, s, cnt, q1, q2, pp, new_s;

/*GA_TYP_Seq_Construct */
/*f[^\ւ̗vA
	eF̒ł̎̓ss𒲂ׂB̈ʒuĂ̎oB
	qF̂ɂǉςׂ݂B
*/
	for(i = 0; i < numKousa; i++ ) {
		q1 = srcOya[i];	CHKA(0, q1, numKousa); ga0->sawkkousa[q1] = i;
		q2 = dsnOya[i];	CHKA(0, q2, numKousa); ga0->sawkval[q2]   = i;
		ga0->edgelist2[i] = 0; 
	}
	/*step1	 ړss(job)ԍ̏lOƂBiŐU邩ȁj
		qF̂ɒǉBiF̂̐擪͏ɂOƂȂj
			ǉ̓ssԍ̒ōŏ̒lێϐPƂB*/
	s = 1;
	pp = 0;   //iŐU邩ȁj
	dsnChild[0] = pp;
	ga0->edgelist2[pp] = 1;
	for( cnt = 1; cnt < numKousa; ++cnt ) {
										CHKA(0, pp, numKousa);
	/*step2  ̐eF̂𒲂ׂĂ̎ɖK₵Ăssq1,q2ƂB*/
		i = ga0->sawkkousa[pp];				CHKA(0, i, numKousa);
		if( ++i >= numKousa ) i = 0;
		q1 = srcOya[i];					CHKA(0, q1, numKousa);
		i = ga0->sawkval[pp];				CHKA(0, i, numKousa);
		if( ++i >= numKousa ) i = 0;
		q2 = dsnOya[i];					CHKA(0, q2, numKousa);
//fprintf(logfp,"cnt(%d)pp(%d)q1(%d)q2(%d)s(%d)\n",cnt, pp, q1, q2, s ); fflush(logfp);
	/*step3	q1qF̂ɒǉς݂Ȃ΁AǉŔԍłssq1ƂBq2ɂĂlB
		ssԍ璲ׂBǉς݂̓ssԂ͂XVB
		iq1,q2ɒǉς݂Ȃ΁AVq1,q2͓ssƂȂj*/
		new_s = s;
		if( ga0->edgelist2[q1] ) {  //q1 ͒ǉ s 璲ג
			for( i = s; i < numKousa; ++i ) {
				if( ga0->edgelist2[i] == 0 ) break;
			}							CHKA(0, i, numKousa);
			new_s = q1 = i;
		}
		if( ga0->edgelist2[q2] ) {  //q2 ͒ǉ s 璲ג
			for( i = s; i < numKousa; ++i ) {
				if( ga0->edgelist2[i] == 0 ) break;
			}							CHKA(0, i, numKousa);
			new_s = q2 = i;
		}
//fprintf(logfp,"new_s(%d)sagyo(%lf)(%lf)\n",new_s, sagyo[pp][q1], sagyo[pp][q2] ); fflush(logfp);
	/*step4	pX[p,q1]̃RXgc1ApX[p,q2]̃RXgc2ƂāAقq1,q2VȂƂB
		qF̂ɒǉB
		q̈`qtinumKousaǉjɂȂIB*/
		if( ga0->sagyo[pp][q1] < ga0->sagyo[pp][q2] ) {
			pp = q1;
		} else {
			pp = q2;
		}
		if( new_s != s && pp == new_s )
			s = new_s + 1;
		dsnChild[cnt] = pp;
		ga0->edgelist2[pp] = 1;
//for( k = 0; k < numKousa; ++k ) fprintf(logfp,"%2d ", dsnChild[k]); fprintf(logfp,"\n");
//for( k = 0; k < numKousa; ++k ) fprintf(logfp,"%2d ", edgelist2[k]); fprintf(logfp,"\n");
	}
	chk_same_point_ga1(dsnChild,numKousa,ga0->chk );
//for( k = 0; k < numKousa; ++k ) fprintf(logfp,"%2d ", dsnChild[k]); fprintf(logfp,"\n");
	return 0;
}

/*	ID_gaCHILD	 e̐F̂Ďq̐F̂쐬
********************************************************************/
static int gaCHILD( //cross_typ, cross_count, oya1, oya2, chrom_ko1, chrom_ko2 )
	int 	cross_typ  ,
	int 	cross_count,
	int 	*oya1	   ,
	int 	*oya2	   ,
	int 	*chrom_ko1 ,
	int 	*chrom_ko2 ,
	class GA1 *ga0)
{
	register int 	i, j, *ks ;
	int 	rc=0 ;
							  CHKB(-1,cross_count,ga0->x_len);
	if(DBGF[7])  fprintf(logfp, "gaCHILD >>> cross_count(%d)\n",cross_count) ;
	if(DBGF[7]>1) { PRINTDC( "osu []=(", ga0->x_len, oya1 ); PRINTDC( "mesu[]=(", ga0->x_len, oya2 ); }
	memset( ga0->kousa, 0, ga0->x_len * sizeof(*ga0->kousa)) ;
	if ( cross_count == CROSS_COUNT_OFF ) {		/*  */
		;
	} else if ( cross_count == CROSS_COUNT_ALL ) {	/* l */
		for( ks = ga0->kousa, i=0 ; i<ga0->x_len ; i++, ++ks )
			*ks = ga0->RANDsk() > 0.5 ;
	} else {		CHKB(1,cross_count,ga0->x_len);		/* cross_count */
		for( i=0 ; i<cross_count ; i++ ) {
			j = (int)(ga0->RANDsk() * ga0->x_len) ; CHKA(0,j,ga0->x_len);
			ga0->kousa[j] = 1 - ga0->kousa[j];
		}
		for( ks = ga0->kousa, j=i=0 ; i<ga0->x_len ; i++, ++ks ) {
			if( *ks ) j = 1 - j;  /* ks = ga0->kousa[i] */
			*ks = j;
		}
	}
	/* for ^Aʒu^*/
	switch ( cross_typ ) {
		case GA_TYP_NORMAL : //0:m[} TSPł͌Ȃ NT130207
			rc = CrossNormal( ga0->x_len, ga0->kousa, oya1, oya2, chrom_ko2, ga0 ) ;
			rc = CrossNormal( ga0->x_len, ga0->kousa, oya2, oya1, chrom_ko1, ga0 ) ;
			break ;
		case GA_TYP_ORDER :	/* 1:^*/
			rc = CrossOrder( ga0->x_len, ga0->kousa, oya1, oya2, chrom_ko2, ga0 ) ;
			rc = CrossOrder( ga0->x_len, ga0->kousa, oya2, oya1, chrom_ko1, ga0 ) ;
			break ;
		case GA_TYP_POSITION :	/* 2:ʒu^*/
			rc = CrossPosition( ga0->x_len, ga0->kousa, oya1, oya2, chrom_ko2 , ga0 ) ;
			rc = CrossPosition( ga0->x_len, ga0->kousa, oya2, oya1, chrom_ko1, ga0 ) ;
			break ;
		case GA_TYP_PARTIALLY_MAPPED :	/* 3:ʑ^*/
			rc = CrossMapped( ga0->x_len, ga0->kousa, oya1, oya2, chrom_ko2, ga0 ) ;
			rc = CrossMapped( ga0->x_len, ga0->kousa, oya2, oya1, chrom_ko1, ga0 ) ;
			break ;
		case GA_TYP_CYCLIC :						/* 4:z^*/
			rc = CrossCyclic( ga0->x_len, ga0->kousa, oya1, oya2, chrom_ko2, ga0 ) ;
			rc = CrossCyclic( ga0->x_len, ga0->kousa, oya2, oya1, chrom_ko1, ga0 ) ;
			break ;
		case GA_TYP_SUBTOUR_EXCHANGING :	/* 5:TucA[^*/
			break ;
		case GA_TYP_EDGE_RECOMBINATION :	/* 6:Ӎđg^*/
			rc = CrossEdgeRecomb( ga0->x_len, ga0->kousa, oya1, oya2, chrom_ko2, ga0 ) ;
			rc = CrossEdgeRecomb( ga0->x_len, ga0->kousa, oya2, oya1, chrom_ko1, ga0 ) ;
			break ;
		case GA_TYP_ALTERNATING_EDGE :	/* 7:ݕӌ^*/
			break ;
		case GA_TYP_SUBTOUR_CHUNKS :		/* 8:oH^*/
			break ;
		case GA_TYP_SEQ_CONSTRUCT : 		/* 9: */
			rc = CrossSeqConstruct( ga0->x_len, ga0->kousa, oya1, oya2, chrom_ko2, ga0 ) ;
			rc = CrossSeqConstruct( ga0->x_len, ga0->kousa, oya2, oya1, chrom_ko1, ga0 ) ;
			break ;
		default:
			CHKA(-1,-1,-1);
			break;
	}
//chk_same_point_ga1(chrom_ko1,ga0->x_len, ga0->chk ); //for test
//chk_same_point_ga1(chrom_ko2,ga0->x_len, ga0->chk ); //for test
	if (DBGF[7]>1) {
		PRINTDC( "kousa[]=(", ga0->x_len, ga0->kousa );
		PRINTDC( "ko1[]=(", ga0->x_len, chrom_ko1 );
		PRINTDC( "ko2[]=(", ga0->x_len, chrom_ko2 );
	}
	if( DBGF[6] ) {
		CheckCr( chrom_ko1, ga0->x_len, ga0) ;
		CheckCr( chrom_ko2, ga0->x_len, ga0) ;
	}
	return( rc ) ;
}
 /* ÓIoϐ́AOŏKvI@ÓIoϐ́ACX^XƂĂԂ͂P */
// int	GA1::test_num = 1;
// struct globals	GA1::c = { 10.0, -1.0 };

/*	ID_ga1_go@f`ŉ
********************************************************************/
int ga1_go( 
	class GA1 *ga0,
//	struct gaparm	*gaparm ,
	int 	(*initmk)(int ** ,int *,int ,int, class GA1 * ) )	/* (i)𔭐֐ */
//	double	(*fitnes)(int*, int) ;		/* (i)KxvZ֐ */
//	double	(*fitnes)(int*, int, double *) ,		/* (i)KxvZ֐ double *kaiǉ */
//	int 	ans[] ,				/* (o)œK */
//	int 	p_allele[] ,		/* (i)̒l̎蓾鐔BPȏ */
//	int 	len )				/* (i)F̒ gap.gene_number */
{
/*	long	rc=0 ;*/
	int		rc=0 ;
	int 	osu, mesu, *oya1, *oya2, i_elite, k_elite, otikobore;
	int 	i, nshare = 0;
	double	total_prob, total_hope, dw1;
	//int 	gaINITMK() ;
	 double oldElite = -1, oldKai = 0 ;
	double kai = 0.0, route_max = 0.0; // 2015.11.20 YS Add
	//struct globals c = { 10.0, -1.0 };
	//class	GA1 ga1;
	GCRO	*wk_gcro ;	/* eq̌p[N */
#ifdef TEST_MUTAT
	GCRO	wk_taro, wk_hana ;	/* ˑRψكeXgp[N */
#endif
#ifdef TEST
		int		t_i;

		t_i = 0;
#endif
	oldElite = -1;	 // 2013.01.21 YS
//	ga0->allele = ga0->allele;
//	/* ga0ɂGAp[^Rs[ */
//	ga0->g = ga0->gap;
//	memset( ga0->ans, 0, sizeof(int) * ga0->gap.gene_number ) ;
	if (DBGF[1]) {
		fprintf(logfp, "ga1>>> gaparm popul_size(%d)gene_number(%d)allele_number(%d)locus_unique(%d)selec_type(%d)cross_rate(%lf)cross_count(%d)mutat_typ(%d)mutat_rate(%lf)elite_prsv(%d)with_repla(%d)sharing(%d)gap(%d)\n",
			ga0->gap.popul_size,ga0->gap.gene_number, ga0->gap.allele_number,ga0->gap.locus_unique,ga0->gap.selec_type,ga0->gap.cross_rate,ga0->gap.cross_count,
			ga0->gap.mutat_typ,ga0->gap.mutat_rate,ga0->gap.elite_prsv,ga0->gap.with_repla,ga0->gap.sharing,ga0->gap.gener_gap) ;
		fprintf(logfp, "initmk(%lx)ans(%lx)", initmk,  ga0->ans);
		fprintf(logfp, "nlen(%d)loop(%d)\n",ga0->gap.gene_number,ga0->gap.loop) ;
	}
	if (DBGF[1]>1) { PRINTDC("allele[]=(",ga0->gap.gene_number,ga0->allele); }
/*  */
	if( (rc = gaINITIAL( ga0->gap.gene_number, ga0 )) < 0 ) 		  goto quit;
/* ̈m */
	if( (rc = gaALLOC( ga0 )) < 0 ) goto quit;
/* ߂ */
	if ( initmk == NULL ) initmk = gaINITMK ;
	(*initmk)( ga0->intgcro, ga0->allele, ga0->x_len, ga0->x_ko, ga0 ) ;
/* KxvZAőKx̂G[gƂ */
	for ( i = 0 ; i < ga0->x_ko ; i++ ) {
//		dw1 = (*fitnes)( ga0->oya_gcro[i].chrom, ga0->x_len ) ;
		if( ga0->gap.problem_type == 1 || ga0->gap.problem_type == 2 || ga0->gap.problem_type == 5) {// problem_typeŕ
			dw1 = ga0->bekiFITNES( ga0->oya_gcro[i].chrom, ga0->x_len, &kai, &ga0->gap) ;
		}
		else if( ga0->gap.problem_type == 3 || ga0->gap.problem_type == 4) {
			dw1 = ga0->bekiFITNES_VRP( ga0->oya_gcro[i].chrom, ga0->x_len, &kai, &ga0->gap, &route_max) ; // rout_max̒ǉ 2015.11.20 YS
		}
		else CHKA(-1,-1,-1);
		ga0->oya_gcro[i].fitnes = dw1;
		ga0->oya_gcro[i].kai = kai; /* 98/08/24 */
		if( dw1 <= EPS ) CHKA(-1,(long)dw1,0); /*v`q*/
		/* eF̂̃`FbN_ʂĂȂH TSPp */
		if (DBGF[10]>2) chk_same_point_ga1(ga0->oya_gcro[i].chrom, ga0->x_len, ga0->chk);
		if(DBGF[0]) fprintf(logfp, "**** i(%d)fitnes(%lf)kai(%lf)\n", i,ga0->oya_gcro[i].fitnes,ga0->oya_gcro[i].kai);
	}
	rc = gaELITE( &i_elite, &otikobore, ga0->oya_gcro, ga0->x_ko );
/* ニ[v */
	for ( ga0->n_loop=0 ; ga0->n_loop<ga0->x_loop ; ga0->n_loop++ ) {
/*		if ( ga0->n_loop>=ga0->x_loop /2) ga0->gap.mutat_rate = ga0->gap.mutat_rate/10 ;*/
		if (DBGF[1]>2) fprintf(logfp, "n_loop(%d)/x_loop(%d)\n",ga0->n_loop,ga0->x_loop) ;
/* ȇIς݃tOnee */
		for( i=0 ; i<ga0->x_ko ; i++ )
			ga0->oya_gcro[i].selsumi = 0 ;
		/* eF̂̃`FbN_ʂĂȂH TSPp */
		if (DBGF[10]>2) for( i=0 ; i<ga0->x_ko ; i++ )	chk_same_point_ga1(ga0->oya_gcro[i].chrom, ga0->x_len, ga0->chk);

/* VFAÔƂA̂̑Iς݃tOIɂ */
		if( ga0->gap.sharing ) nshare = gaSHARE( ga0->oya_gcro, ga0 );
/* KxIm߂ */
		if ((rc=gaPROB( &total_prob, &total_hope, ga0->gap.selec_type, ga0->oya_gcro, ga0 )) < 0 ) goto quit ;
		if ( total_hope <= 0.0 ) break ;

		for( ga0->n_ko=0 ; ga0->n_ko + 2 <= ga0->gap.gener_gap ; ) {
/* ẽyA쐬 */
			if ( gaPAIR( ga0->oya_gcro, ga0->gap.with_repla, ga0->gap.sharing,
								&osu, &mesu, total_hope, ga0 ) < 0 ) break ;
					CHKA( 0, osu, ga0->x_ko); CHKA( 0, mesu, ga0->x_ko);
/* eq邩H(邩H) */
			if (ga0->gaKOUSA( ga0->gap.cross_rate ) <= 0 ) continue ;
/* Ғl̍XV */
			gaCHANGE_PROB( &ga0->oya_gcro[osu], &ga0->oya_gcro[mesu], &total_hope, ga0 );
/* Ďq쐬 */
						CHKB(2,ga0->n_ko+2,ga0->x_ko);
			oya1 = ga0->oya_gcro[osu].chrom;
			oya2 = ga0->oya_gcro[mesu].chrom;
			/* eF̂̃`FbN_ʂĂȂH TSPp */
			if (DBGF[10]>2) {
				chk_same_point_ga1(oya1, ga0->x_len, ga0->chk );
				chk_same_point_ga1(oya2, ga0->x_len, ga0->chk );
			}
			/* ga0ga0sagyöʒu@QƉ\ɂ */
			ga0->sagyo = ga0->sagyo;
			rc = gaCHILD( ga0->gap.cross_typ, ga0->gap.cross_count, oya1, oya2, ga0->taro_gcro.chrom, ga0->hana_gcro.chrom, ga0 ) ;
			/* ˑRψق́AψّO悭ȂˑRψق悤ɂꍇ̃eXgp 2013.01.25 */
#ifdef TEST_MUTAT
			memcpy( &wk_taro, &ga0->taro_gcro, sizeof(GCRO ) ) ;
			wk_taro.fitnes = (*fitnes)( wk_taro.chrom, ga0->x_len, &kai ) ;
			wk_taro.kai = kai ; /* 98/08/24 */
			memcpy( &wk_hana, &ga0->hana_gcro, sizeof( GCRO ) ) ;
			wk_hana.fitnes = (*fitnes)( wk_hana.chrom, ga0->x_len, &kai ) ;
			wk_hana.kai = kai ; /* 98/08/24 */
#endif
/* qQl̓ˑRψ */
/*			rc = gaMUTAT( ga0->gap.mutat_rate, oya1, oya2, ga0->taro_gcro.chrom, ga0->hana_gcro.chrom ) ;*/
			rc = gaMUTAT( ga0->gap.mutat_typ, ga0->gap.mutat_rate, oya1, oya2, ga0->taro_gcro.chrom, ga0->hana_gcro.chrom, ga0 ) ;
			if (DBGF[10]>2) {
				chk_same_point_ga1(ga0->taro_gcro.chrom, ga0->x_len, ga0->chk );
				chk_same_point_ga1(ga0->hana_gcro.chrom, ga0->x_len, ga0->chk );
			}
/* q̓KxvZ */
//			ga0->taro_gcro.fitnes = (*fitnes)( ga0->taro_gcro.chrom, ga0->x_len ) ;
//			ga0->hana_gcro.fitnes = (*fitnes)( ga0->hana_gcro.chrom, ga0->x_len ) ;
			// VRP CVRṔASł͂ȂA[gl`w
			if( ga0->gap.problem_type == VRP || ga0->gap.problem_type == CVRP ) {
				ga0->taro_gcro.fitnes = ga0->bekiFITNES_VRP( ga0->taro_gcro.chrom, ga0->x_len, &kai, &ga0->gap, &route_max) ; // rout_max̒ǉ 2015.11.20 YS
//KS20150721chg	ga0->taro_gcro.kai = ga0->route_max ; /* 13/06/19 */
				ga0->taro_gcro.kai = kai ; /* 13/06/19 */
				ga0->hana_gcro.fitnes = ga0->bekiFITNES_VRP( ga0->hana_gcro.chrom, ga0->x_len, &kai, &ga0->gap , &route_max) ; // rout_max̒ǉ 2015.11.20 YS
//KS20150721chg	ga0->hana_gcro.kai = ga0->route_max ; /* 13/06/19 */
				ga0->hana_gcro.kai = kai; /* 13/06/19 */
			}
			else if( ga0->gap.problem_type == TSP || ga0->gap.problem_type == ATSP || ga0->gap.problem_type == MTSP ) {
				ga0->taro_gcro.fitnes = ga0->bekiFITNES( ga0->taro_gcro.chrom, ga0->x_len, &kai, &ga0->gap) ;
				ga0->taro_gcro.kai = kai ; /* 98/08/24 */
				ga0->hana_gcro.fitnes = ga0->bekiFITNES( ga0->hana_gcro.chrom, ga0->x_len, &kai, &ga0->gap ) ;
				ga0->hana_gcro.kai = kai ; /* 98/08/24 */
			}
			else CHKA(-1,-1,-1);
#ifdef TEST_MUTAT
			if( rc == 1 ) { /* ˑRψقȂȂOƂ悭ȂĂ邩ׂ */
				if( ga0->taro_gcro.fitnes < wk_taro.fitnes ) {
					memcpy( &ga0->taro_gcro,&wk_taro, sizeof( GCRO ) ) ;
				}
				if( ga0->hana_gcro.fitnes < wk_hana.fitnes ) {
					memcpy( &ga0->hana_gcro,&wk_hana, sizeof( GCRO ) ) ;
				}
			}
#endif
			if( ga0->taro_gcro.fitnes < -1-EPS ) CHKA(-1,(long)ga0->taro_gcro.fitnes,0); /*v`qȊÓ[*/
			if( ga0->hana_gcro.fitnes < -1-EPS ) CHKA(-1,(long)ga0->hana_gcro.fitnes,0); /*v`qȊÓ[*/
/* q̎qւ̒ǉ */
			if( ga0->taro_gcro.fitnes > 0.0 && ga0->n_ko < ga0->gap.gener_gap )
				gaCOPY_GCRO( &ga0->ko_gcro[ga0->n_ko++], &ga0->taro_gcro );
			if( ga0->hana_gcro.fitnes > 0.0 && ga0->n_ko < ga0->gap.gener_gap )
				gaCOPY_GCRO( &ga0->ko_gcro[ga0->n_ko++], &ga0->hana_gcro );
		}
		/* q`q̃`FbN_ʂĂȂH TSPp */
		if (DBGF[10]>2) for( i=0 ; i<ga0->n_ko ; i++ )		chk_same_point_ga1(ga0->ko_gcro[i].chrom, ga0->x_len, ga0->chk );

/* q̌ȂAeォRs[ */
		rc=gaIKINOKORI( ga0->gap.with_repla, ga0->gap.sharing, ga0->oya_gcro, ga0->ko_gcro, &ga0->n_ko, ga0 ) ;
							CHKB(ga0->x_ko,ga0->n_ko,ga0->x_ko);
/* G[g̕ۑ */
		rc = gaELITE( &k_elite, &otikobore, ga0->ko_gcro, ga0->x_ko );
		if ( ga0->gap.elite_prsv == ELITE_PRSV_ON ) {
								CHKA(0,i_elite,ga0->x_ko);
								CHKA(0,k_elite,ga0->x_ko);
								CHKA(0,otikobore,ga0->x_ko);
/* q̃G[g̓KxƔr */
			if ( ga0->ko_gcro[k_elite].fitnes < ga0->oya_gcro[i_elite].fitnes ) {
				if (DBGF[1]>2) fprintf(logfp, "i_elite fitnes(%e) ---> ko[%d]\n",
							ga0->oya_gcro[i_elite].fitnes, otikobore ) ;
/* ẽG[gqɃRs[ */
				gaCOPY_GCRO( &ga0->ko_gcro[otikobore], &ga0->oya_gcro[i_elite] );
				k_elite = otikobore;
//KS130820chg	if( t_i > 0 ) CHKAD(0.0,t[t_i-1].fitnes,ga0->oya_gcro[i_elite].fitnes);
				if( t_i > 0 ) CHKBD(0.0,t[t_i-1].fitnes,ga0->oya_gcro[i_elite].fitnes);
			}
		}
/* Bga0->oya_gcroga0->ko_gcro */
		wk_gcro    = ga0->ko_gcro;
		ga0->ko_gcro  = ga0->oya_gcro;
		ga0->oya_gcro = wk_gcro;
		i_elite = k_elite;
		//if ( (oldElite - ga0->oya_gcro[i_elite].fitnes) < -1.0E-4 || (oldElite - ga0->oya_gcro[i_elite].fitnes) > 1.0E-4 ) { 2013.01.21 YS
		if ( (oldElite - ga0->oya_gcro[i_elite].fitnes) < -1.0E-4  ) { // qɐe肢KxoƂ̂ݏo͂
			if(DBGF[0]) fprintf(logfp, "loop(%d)elite(%lf)share(%d)ko(%d)kai(%lf)\n",
			ga0->n_loop, ga0->oya_gcro[i_elite].fitnes, nshare, ga0->x_ko, ga0->oya_gcro[i_elite].kai ), fflush(logfp);
			oldElite = ga0->oya_gcro[i_elite].fitnes ;
		}
#ifdef TEST  // œKƂ̍كOtp@㐔̉̕ێ
		if(DBGF[0]&& (ga0->n_loop%100 == 0)) fprintf(logfp, "loop(%d)elite(%lf)share(%d)ko(%d)kai(%lf)\n",
			ga0->n_loop, ga0->oya_gcro[i_elite].fitnes, nshare, ga0->x_ko, ga0->oya_gcro[i_elite].kai ), fflush(logfp);
		//if( t_i > 0 ) CHKAD(0.0,ga0->oya_gcro[i_elite].kai,t[t_i-1].kai);
		if( ga0->n_loop == t[t_i].loop ) {
			t[t_i].kai = ga0->oya_gcro[i_elite].kai;
			t[t_i].fitnes = ga0->oya_gcro[i_elite].fitnes;
//KS130820chg	if( t_i > 0 ) CHKAD(0.0,t[t_i-1].fitnes,t[t_i].fitnes);
			if( t_i > 0 ) CHKBD(0.0,t[t_i-1].fitnes,t[t_i].fitnes);
			t_i++;
		}
#endif
	}
	/* ŏI͖`FbN */
	chk_same_point_ga1(ga0->ko_gcro[i_elite].chrom, ga0->x_len, ga0->chk );

/* ŗǉ̎oiG[gIj*/
						   CHKA(0,i_elite,ga0->x_ko);
	memcpy( ga0->ans, ga0->oya_gcro[i_elite].chrom, sizeof( int ) * ga0->x_len ) ;
/*sv	rc = ga0->oya_gcro[i_elite].fitnes	;*/

/* free */
	//gaFINAL(ga0 ) ; //oya_gcro[](e̐F̏)邽 BĂяotsp_Final()
quit :
	if (DBGF[1])  fprintf(logfp, "<<<ga1 rc(%ld)min_val(%le)max_val(%le)\n",rc,ga0->min_val,ga0->max_val) ;
	if (DBGF[1]>1) { PRINTDC( "ans=(", ga0->x_len, ga0->ans ); }
	return( rc ) ;
}
/*	ID_get_ans	lsfunc ɂāASĂ ans[] vZāAœK߂ۂɎgp@eXgp
********************************************************************/
void GA1::get_ans( int n, int *ansL ) //eXgp Ƃŏ
{
	memcpy( ansL, oya_gcro[n].chrom, sizeof( int ) * x_len ) ;
	return;
}

